/*
	2022 year
	Math libs  $continue$
*/

/*
	include guard
*/

#if defined _math_libs
	#endinput
#endif
#define _math_libs

/*
	functions
*/

stock math@GetPolyPointsRotatedRect(const Float: x_center, const Float: y_center, const Float: angle, const Float: width, const Float: height, Float: points[4][2])
{
	new Float: x1 = -floatsin(angle, degrees);
	new Float: y1 = floatcos(angle, degrees);
	new Float: x2 = -y1;
	new Float: y2 =  x1;
	new Float: half_width = width / 2.0;
	new Float: half_height = height / 2.0;

	x1 *= half_height;
	y1 *= half_height;
	x2 *= half_width;
	y2 *= half_width;

	points[0][0] = x_center + x1 + x2;
	points[0][1] = y_center + y1 + y2;
	points[1][0] = x_center + x1 - x2; 
	points[1][1] = y_center + y1 - y2;

	points[2][0] = x_center - x1 - x2;
	points[2][1] = y_center - y1 - y2;
	points[3][0] = x_center - x1 + x2;
	points[3][1] = y_center - y1 + y2;
	return 1;
}

stock math@GetSemicirclePolyPoint(
	Float: cx,
	Float: cy, 
	Float: angle, 
	Float: radius, 
	Float: dest[], 
	const points = sizeof(dest)
) 
{
	new Float: diff = 180.0 / (points / 2 - 1);
	new Float: a = angle + diff / 2.0;
	new Float: mbase;
	new Float: m1;
	new Float: b1;
	new Float: m2;
	new Float: b2;

	m1 = mbase = floattan(angle, degrees);

	new p = 2;
	for (; p < points; a += diff) 
	{
		/*
			forumula from wikipedia: 

			for x: d - c / a - b
			for y: a * (d - c / a - b) + const
		*/

		m2 = -1.0 / floattan(a, degrees);
		b2 =  1.0 / floatsin(a, degrees);

		dest[p++] = cx + (m1 = ((b2 - b1) / (m1 - m2))) * radius;
		dest[p++] = cy + (m2 * m1 + b2) * radius;

		m1 = m2;
		b1 = b2;
	}
	dest[0] = cx + (m1 = b1 / (mbase - m1)) * radius;
	dest[1] = cy + (mbase * m1) * radius;
	return p;
}