#define YEAR0           1900            /* the first n_year */
#define EPOCH_YR        1970            /* EPOCH = Jan 1 1970 00:00:00 */
#define SECS_DAY        (24 * 60 * 60)
#define LEAPYEAR(%0)    (!((%0) % 4) && (((%0) % 100) || !((%0) % 400)))
#define YEARSIZE(%0)    (LEAPYEAR(%0) ? 366 : 365)
#define TIME_MAX        cellmax

static const _ytab[2][12] = {
	{ 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 },
	{ 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 }
};


stock date_to_timestamp
(
	n_year = 1970,	n_month  = 1,	n_day    = 1,
	n_hour =    0,	n_minute = 0,	n_second = 0
)
{
	switch ( n_month )
	{
		case  2 : n_day +=  31;	case  3 : n_day +=  59;	case  4 : n_day +=  90;
		case  5 : n_day += 120;	case  6 : n_day += 151;	case  7 : n_day += 181;
		case  8 : n_day += 212;	case  9 : n_day += 243;	case 10 : n_day += 273;
		case 11 : n_day += 304;	case 12 : n_day += 334;
	}

	return ( n_second + n_minute*60 + n_hour*3600 + (n_day - 1)*86400
		+ (n_year - 1970)*31557600 + ( n_year % 4 == 0 ? 21600 : 0 ) );
}


stock timestamp_to_date
(
	unix_timestamp = 0,

	& n_year = 1970,		& n_month  = 1,		& n_day    = 1,
	& n_hour =    0,		& n_minute = 0,		& n_second = 0
)
{
	n_year = unix_timestamp /  31557600;
	unix_timestamp -= n_year *  31557600;
	n_year += 1970;

	if ( n_year % 4 == 0 ) unix_timestamp -= 21600;

	n_day = unix_timestamp / 86400;

	switch ( n_day )
	{
		//  n_second     
		case    0..30 : { n_second = n_day;       n_month =  1; }
		case   31..58 : { n_second = n_day -  31; n_month =  2; }
		case   59..89 : { n_second = n_day -  59; n_month =  3; }
		case  90..119 : { n_second = n_day -  90; n_month =  4; }
		case 120..150 : { n_second = n_day - 120; n_month =  5; }
		case 151..180 : { n_second = n_day - 151; n_month =  6; }
		case 181..211 : { n_second = n_day - 181; n_month =  7; }
		case 212..242 : { n_second = n_day - 212; n_month =  8; }
		case 243..272 : { n_second = n_day - 243; n_month =  9; }
		case 273..303 : { n_second = n_day - 273; n_month = 10; }
		case 304..333 : { n_second = n_day - 304; n_month = 11; }
		case 334..366 : { n_second = n_day - 334; n_month = 12; }
	}

	unix_timestamp -= n_day * 86400;
	n_hour = unix_timestamp / 3600;

	unix_timestamp -= n_hour * 3600;
	n_minute = unix_timestamp / 60;

	unix_timestamp -= n_minute * 60;
	n_day = n_second + 1;
	n_second = unix_timestamp;
}

/*
	         
	    UNIX TIMESTAMP

	
		UNIX TIMESTAMP  -    01.01.1970, 00:00:00 
		   .    ,  
		 format      
		       UNIX TIMESTAMP.

		 :	 :
		%yyyy			  
		%yy			     
		%m			 
		%mm			    
		%d			 
		%dd			    
		%h			 
		%hh			    
		%i			 
		%ii			    
		%s			 
		%ss			    

	
		       
		  = sizeOfOutput
*/
stock date ( const formatStr[] = "%dd.%mm.%yyyy, %hh:%ii:%ss", timestamp = 0 )
{
	// ------------
	const sizeOfOutput = 128; //   

	new yyyy, mm, dd, h, m, s,
		pos, foundPos, searchStartPos, outStrLen,
		tmpNumStr[5], outStr[sizeOfOutput];

	//timestamp_to_date( timestamp+75600, yyyy,mm,dd, h,m,s ); //    
	gmtime(timestamp + 10800, yyyy, mm, dd, h, m, s);
	// ------------


	// -------------------
	//  formatStr  outStr
	memcpy( outStr, formatStr, 0, (sizeOfOutput - 1)*4 );
	outStr[sizeOfOutput - 1] = 0; //      

	outStrLen = strlen(outStr);
	// -------------------


	// YEAR
	// -------------------
	searchStartPos = 0; //    = 0
	foundPos = strfind( outStr, "%yyyy", false, searchStartPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 5, "%04d", yyyy ); // tmpNumStr =   yyyy

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 4; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		for ( pos += foundPos; pos < outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		searchStartPos = foundPos + 4; //   .  += 4

		if ( searchStartPos < outStrLen ) //       
			foundPos = strfind( outStr, "%yyyy", false, searchStartPos ); //  
		else break; //  -    
	}
	// -------------------


	// -------------------
	searchStartPos = 0; //    = 0
	foundPos = strfind( outStr, "%yy", false, searchStartPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 5, "%04d", yyyy ); // tmpNumStr =   yyyy

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos + 2];

		//    1   
		for ( pos += foundPos; pos <= outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		searchStartPos = foundPos + 2; //   .  

		if ( searchStartPos < outStrLen ) //       
			foundPos = strfind( outStr, "%yy", false, searchStartPos ); //  
		else break; //  -    
	}
	// -------------------


	// MONTH
	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%mm", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%02d", mm ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		for ( pos += foundPos; pos <= outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%mm", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%m", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%d", mm ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		if ( mm < 10 )
		{
			for ( pos += foundPos; pos <= outStrLen; pos++ )
				outStr[pos] = outStr[pos + 1];

			outStr[pos] = 0; //   
			outStrLen = strlen(outStr); //   
			foundPos++; //   .  
		}
		else
			foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%m", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// DAY
	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%dd", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%02d", dd ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		for ( pos += foundPos; pos <= outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%dd", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%d", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%d", dd ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		if ( dd < 10 )
		{
			for ( pos += foundPos; pos <= outStrLen; pos++ )
				outStr[pos] = outStr[pos + 1];

			outStr[pos] = 0; //   
			outStrLen = strlen(outStr); //   
			foundPos++; //   .  
		}
		else
			foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%d", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// HOUR
	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%hh", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%02d", h ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		for ( pos += foundPos; pos <= outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%hh", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%h", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%d", h ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		if ( h < 10 )
		{
			for ( pos += foundPos; pos <= outStrLen; pos++ )
				outStr[pos] = outStr[pos + 1];

			outStr[pos] = 0; //   
			outStrLen = strlen(outStr); //   
			foundPos++; //   .  
		}
		else
			foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%h", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// MINUTE
	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%ii", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%02d", m ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		for ( pos += foundPos; pos <= outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%ii", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%i", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%d", m ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		if ( m < 10 )
		{
			for ( pos += foundPos; pos <= outStrLen; pos++ )
				outStr[pos] = outStr[pos + 1];

			outStr[pos] = 0; //   
			outStrLen = strlen(outStr); //   
			foundPos++; //   .  
		}
		else
			foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%i", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// SECOND
	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%ss", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%02d", s ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		for ( pos += foundPos; pos <= outStrLen; pos++ )
			outStr[pos] = outStr[pos + 1];

		outStr[pos] = 0; //   
		outStrLen = strlen(outStr); //   
		foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%ss", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	// -------------------
	foundPos = 0; //    = 0
	foundPos = strfind( outStr, "%s", false, foundPos ); //   

	while ( foundPos != -1 )
	{
		format( tmpNumStr, 3, "%d", s ); // tmpNumStr =   

		for ( pos = 0; tmpNumStr[pos] != 0 && pos < 2; pos++ ) //    
			outStr[foundPos + pos] = tmpNumStr[pos];

		//    1   
		if ( s < 10 )
		{
			for ( pos += foundPos; pos <= outStrLen; pos++ )
				outStr[pos] = outStr[pos + 1];

			outStr[pos] = 0; //   
			outStrLen = strlen(outStr); //   
			foundPos++; //   .  
		}
		else
			foundPos += 2; //   .  

		if ( foundPos < outStrLen ) //       
			foundPos = strfind( outStr, "%s", false, foundPos ); //  
		else break; //  -    
	}
	// -------------------


	return outStr;
}

stock gmtime(timestamp, &n_year = EPOCH_YR, &n_month = 1, &n_day = 1, &n_hour = 0, &n_minute = 0, &n_second = 0)
{
	static dayclock;

	n_year = EPOCH_YR;
	dayclock = timestamp % SECS_DAY;
	n_day = timestamp / SECS_DAY;

	n_second = dayclock % 60;
	n_minute = (dayclock % 3600) / 60;
	n_hour = dayclock / 3600;

	while (n_day >= YEARSIZE(n_year)) {
		n_day -= YEARSIZE(n_year);
		n_year++;
	}

	n_month = 0;

	while (n_day >= _ytab[LEAPYEAR(n_year)][n_month]) {
		n_day -= _ytab[LEAPYEAR(n_year)][n_month];
		n_month++;
	}

	n_day++;
	n_month++;
}