#define MAX_ACCESORY_BUY_MAX_PAGE		(7)
#define MAX_ACCESORY_BUY_MAX_ITEMS_PAGE	(12)
#define MAX_ACCESORY_TYPE				(5)

static Text:BuyAccesoryTD[14], PlayerText:BuyAccesoryPTD[MAX_PLAYERS][34];
new nameItems[][] = {"", "", "", "", ""};

enum E_ACCESORY_TYPE
{
	typeItemID[156],
	typeItemsCount,
	typePages,
}
new AccesoryTypeInfo[MAX_ACCESORY_TYPE][E_ACCESORY_TYPE];

as_OnGameModeInit()
{
	for (new i, idx, type; i < sizeof (gInventoryItem); i++)
	{
		if (gInventoryItem[i][asIndex] == INDEX_SELL_OTHER) continue;
		type = gInventoryItem[i][asType];
		if (!type) continue;
		idx = AccesoryTypeInfo[type - 1][typeItemsCount]++;
		AccesoryTypeInfo[type - 1][typeItemID][idx] = i;
	}
	for (new type = 1; type <= MAX_ACCESORY_TYPE; type++) AccesoryTypeInfo[type - 1][typePages] = 1 + AccesoryTypeInfo[type - 1][typeItemsCount] / MAX_ACCESORY_BUY_MAX_ITEMS_PAGE;
	CreateAccesoryBuyTD();
}

as_OnPlayerClickTextDraw(playerid, Text:clickedid)
{
	if (!pTemp[playerid][tAccesoryBuyMenuShowed]) return false;
	if (clickedid == BuyAccesoryTD[8])
	{ // (click EXIT)
		HideAccesoryBuyMenu(playerid);
		return true;
	}
	else if (clickedid == BuyAccesoryTD[9])
	{ // (click BUY)
		new itemid, id = pTemp[playerid][tAccesoryBuySelectID];
		if (id == -1) return ErrorMessage(playerid, "    !");
		itemid = AccesoryTypeInfo[pTemp[playerid][tAccesoryBuyType] - 1][typeItemID][id + ((pTemp[playerid][tAccesoryBuyPage] - 1) * MAX_ACCESORY_BUY_MAX_ITEMS_PAGE)];
		//if (!FreeSlotPlayerItem(playerid)) return 1; 
		new price = gInventoryItem[itemid][asPrice];
		new balance_ = (gInventoryItem[itemid][asPrice]*80)/100; // 80 %  
		if (kLibGetPlayerMoney(playerid) < price) return ErrorMessage(playerid, "     !");
		new business_id = pTemp[playerid][tBusinessID];
		if (BusinessInfo[business_id][bProducts] < 100) return ErrorMessage(playerid, "   !");

		BusinessInfo[business_id][bProducts] -= 100;
		PayBusinessItem(playerid, business_id, 0, 1, balance_);
		
		AddInventoryItem(playerid, gInventoryItem[itemid][iItemID], 1);
		SendOk(playerid, ":   .    !");
		return true;
	}
	else if (clickedid == Text:INVALID_TEXT_DRAW)
	{
		SelectTextDraw(playerid, 0xFF7F50FF);
		return true;
	}
	return false;
}

as_OnPlayerClickPTD(playerid, PlayerText:playertextid)
{
	if (!pTemp[playerid][tAccesoryBuyMenuShowed]) return false;
	if (playertextid == BuyAccesoryPTD[playerid][12])
	{ // (click TYPE)
		new string[156];
		for (new i = 1; i <= MAX_ACCESORY_TYPE; i++) format(string, sizeof (string), "%s[%i] %s\t[%i .]\n", string, i, nameItems[i - 1], AccesoryTypeInfo[i - 1][typeItemsCount]);
		SPD(playerid, D_ITEMS_BUY_TYPE, DIALOG_STYLE_TABLIST, ""colserver": "colwhi" ", string, "", "");
		string[0] = EOS;
		return true;
	}
	new bool:isReturn = false;
	for (new i = 0; i < MAX_ACCESORY_BUY_MAX_PAGE; i++)
	{ // (click PAGE:1-7)
		if (playertextid != BuyAccesoryPTD[playerid][i + 26]) continue;
		UpdateAccesoryBuyMenuPage(playerid, i + 1);
		isReturn = true;
		break;
	}
	if (isReturn) return true;
	for (new i = 0; i < MAX_ACCESORY_BUY_MAX_ITEMS_PAGE; i++)
	{
		if (playertextid != BuyAccesoryPTD[playerid][i]) continue;
		if (i == pTemp[playerid][tAccesoryBuySelectID]) continue;
		if (pTemp[playerid][tAccesoryBuySelectID] != -1)
		{
			PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][pTemp[playerid][tAccesoryBuySelectID]], COLOR_SERVER);
			PlayerTextDrawShow(playerid, BuyAccesoryPTD[playerid][pTemp[playerid][tAccesoryBuySelectID]]);
		}
		PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][i], -2139094785);
		PlayerTextDrawShow(playerid, BuyAccesoryPTD[playerid][i]);
		pTemp[playerid][tAccesoryBuySelectID] = i;

		isReturn = true;
		break;
	}
	if (isReturn) return true;
	return false;
}

stock SetAccesoryBuyType(playerid, type)
{
	new string[24];
	switch (type)
	{
		case TYPE_ITEMS_COMMON: string = "COMMON";
		case TYPE_ITEMS_RARE: string = "RARE";
		case TYPE_ITEMS_MYTHICAL: string = "MYTHICAL";
		case TYPE_ITEMS_LEGENDARY: string = "LEGENDARY";
		case TYPE_ITEMS_UNIQUE: string = "UNIQUE";
	}
	PlayerTextDrawSetString(playerid, BuyAccesoryPTD[playerid][13], string), string[0] = EOS;
	pTemp[playerid][tAccesoryBuyPage] = 0;
	pTemp[playerid][tAccesoryBuyType] = type;

	PlayerTextDrawShow(playerid, BuyAccesoryPTD[playerid][33]);
	UpdateAccesoryBuyMenuPage(playerid);
	return true;
}

stock UpdateAccesoryBuyMenu(playerid, type)
{
	new page = pTemp[playerid][tAccesoryBuyPage], string[12]; 
	pTemp[playerid][tAccesoryBuySelectID] = -1;

	for (new i = 0, itemid; i < MAX_ACCESORY_BUY_MAX_ITEMS_PAGE; i++)
	{
		itemid = AccesoryTypeInfo[type - 1][typeItemID][i + ((page - 1) * MAX_ACCESORY_BUY_MAX_ITEMS_PAGE)];
		if (itemid < sizeof (gInventoryItem) && gInventoryItem[itemid][asType] == type)
		{
			PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][i], COLOR_SERVER);
			PlayerTextDrawSetPreviewModel(playerid, BuyAccesoryPTD[playerid][i], gInventoryItem[itemid][iItemID]);
			PlayerTextDrawSetPreviewRot(playerid, BuyAccesoryPTD[playerid][i], gInventoryItem[itemid][iItemPosX], gInventoryItem[itemid][iItemPosY], gInventoryItem[itemid][iItemPosZ], gInventoryItem[itemid][iItemPosC]);
			PlayerTextDrawSetSelectable(playerid, BuyAccesoryPTD[playerid][i], true);
			format(string, sizeof (string), "%i", gInventoryItem[itemid][asPrice]);
			PlayerTextDrawSetString(playerid, BuyAccesoryPTD[playerid][i + 14], string), string[0] = EOS;
		}
		else
		{
			PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][i], 0x000000FF);
			PlayerTextDrawSetPreviewModel(playerid, BuyAccesoryPTD[playerid][i], 0);
			PlayerTextDrawSetPreviewRot(playerid, BuyAccesoryPTD[playerid][i], 0.000000, 0.000000, 0.000000, 100.000000);
			PlayerTextDrawSetSelectable(playerid, BuyAccesoryPTD[playerid][i], false);
			PlayerTextDrawSetString(playerid, BuyAccesoryPTD[playerid][i + 14], " ");
		}
		PlayerTextDrawShow(playerid, BuyAccesoryPTD[playerid][i]);
	}
	pTemp[playerid][tAccesoryBuyType] = type;
}

stock UpdateAccesoryBuyMenuPage(playerid, page = 1)
{
	new type = pTemp[playerid][tAccesoryBuyType], maxPage = AccesoryTypeInfo[type - 1][typePages];

	if (page > maxPage) page = maxPage;
	if (page == pTemp[playerid][tAccesoryBuyPage]) return;

	for (new i = 0; i < MAX_ACCESORY_BUY_MAX_PAGE; i++)
	{
		if (i >= maxPage) PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][i + 26], 0x000000FF);
		else if (page == (i + 1)) PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][i + 26], COLOR_SERVER);
		else PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][i + 26], -2139062017);
		PlayerTextDrawShow(playerid, BuyAccesoryPTD[playerid][i + 26]);
	}
	pTemp[playerid][tAccesoryBuyPage] = page; 
	UpdateAccesoryBuyMenu(playerid, type);
}

stock HideAccesoryBuyMenu(playerid)
{ 
	if (!pTemp[playerid][tAccesoryBuyMenuShowed]) return false;

	for (new td_id = 0; td_id < sizeof (BuyAccesoryTD); td_id++) TextDrawHideForPlayer(playerid, BuyAccesoryTD[td_id]);
	for (new td_id = 0; td_id < sizeof (BuyAccesoryPTD[]); td_id++) PlayerTextDrawDestroy(playerid, BuyAccesoryPTD[playerid][td_id]);
	pTemp[playerid][tAccesoryBuyMenuShowed] = false;
	TogglePlayerControllable(playerid, true);
	CancelSelectTextDraw(playerid);

	new id = pTemp[playerid][tBusinessID], interior_id = BusinessInfo[id][bInteriorID];
	PressedPickup[playerid] = BusinessInfo[id][bBuyPickup];

	SetPlayerPosAC(playerid, BusinessInteriorInfo[interior_id][bIntMenuPos][0], BusinessInteriorInfo[interior_id][bIntMenuPos][1], BusinessInteriorInfo[interior_id][bIntMenuPos][2], BusinessInfo[id][bWorld], BusinessInteriorInfo[interior_id][bIntInterior]);
	SetPlayerFacingAngle(playerid, 0.000);

	TogglePlayerControllable(playerid, true);
	SetCameraBehindPlayer(playerid);
	return true;
}

stock ShowAccesoryBuyMenu(playerid)
{ 
	if (pTemp[playerid][tAccesoryBuyMenuShowed]) return false;

	BuyAccesoryPTD[playerid][0] = CreatePlayerTextDraw(playerid, 16.100000, 144.922103, "previewModel");
	BuyAccesoryPTD[playerid][1] = CreatePlayerTextDraw(playerid, 49.233310, 144.922103, "previewModel");
	BuyAccesoryPTD[playerid][2] = CreatePlayerTextDraw(playerid, 82.366622, 144.922103, "previewModel");
	BuyAccesoryPTD[playerid][3] = CreatePlayerTextDraw(playerid, 115.499931, 144.922103, "previewModel");

	BuyAccesoryPTD[playerid][4] = CreatePlayerTextDraw(playerid, 16.100000, 180.722106, "previewModel");
	BuyAccesoryPTD[playerid][5] = CreatePlayerTextDraw(playerid, 49.233310, 180.722106, "previewModel");
	BuyAccesoryPTD[playerid][6] = CreatePlayerTextDraw(playerid, 82.366622, 180.722106, "previewModel");
	BuyAccesoryPTD[playerid][7] = CreatePlayerTextDraw(playerid, 115.499931, 180.722106, "previewModel");

	BuyAccesoryPTD[playerid][8] = CreatePlayerTextDraw(playerid, 16.100000, 216.522109, "previewModel");
	BuyAccesoryPTD[playerid][9] = CreatePlayerTextDraw(playerid, 49.233310, 216.522109, "previewModel");
	BuyAccesoryPTD[playerid][10] = CreatePlayerTextDraw(playerid, 82.366622, 216.522109, "previewModel");
	BuyAccesoryPTD[playerid][11] = CreatePlayerTextDraw(playerid, 115.499931, 216.522109, "previewModel");

	BuyAccesoryPTD[playerid][12] = CreatePlayerTextDraw(playerid, 59.166667, 283.000000, "LD_SPAC:white"); // click TYPE
	PlayerTextDrawTextSize(playerid, BuyAccesoryPTD[playerid][12], 48.000000, 18.000000);
	PlayerTextDrawAlignment(playerid, BuyAccesoryPTD[playerid][12], 1);
	PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][12], -2139094785);
	PlayerTextDrawSetShadow(playerid, BuyAccesoryPTD[playerid][12], 0);
	PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][12], 255);
	PlayerTextDrawFont(playerid, BuyAccesoryPTD[playerid][12], 4);
	PlayerTextDrawSetProportional(playerid, BuyAccesoryPTD[playerid][12], 0);
	PlayerTextDrawSetSelectable(playerid, BuyAccesoryPTD[playerid][12], true);

	BuyAccesoryPTD[playerid][13] = CreatePlayerTextDraw(playerid, 83.983345, 287.144531, "COMMON"); // name of TYPE
	PlayerTextDrawLetterSize(playerid, BuyAccesoryPTD[playerid][13], 0.234163, 1.019255);
	PlayerTextDrawAlignment(playerid, BuyAccesoryPTD[playerid][13], 2);
	PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][13], -1);
	PlayerTextDrawSetShadow(playerid, BuyAccesoryPTD[playerid][13], 0);
	PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][13], 255);
	PlayerTextDrawFont(playerid, BuyAccesoryPTD[playerid][13], 1);
	PlayerTextDrawSetProportional(playerid, BuyAccesoryPTD[playerid][13], 1);

	BuyAccesoryPTD[playerid][14] = CreatePlayerTextDraw(playerid, 46.866649, 172.370407, "0");
	BuyAccesoryPTD[playerid][15] = CreatePlayerTextDraw(playerid, 80.199981, 172.370422, "0");
	BuyAccesoryPTD[playerid][16] = CreatePlayerTextDraw(playerid, 113.133300, 172.370407, "0");
	BuyAccesoryPTD[playerid][17] = CreatePlayerTextDraw(playerid, 146.466659, 172.370407, "0");
	BuyAccesoryPTD[playerid][18] = CreatePlayerTextDraw(playerid, 46.866649, 207.966720, "0");
	BuyAccesoryPTD[playerid][19] = CreatePlayerTextDraw(playerid, 80.199981, 207.966720, "0");
	BuyAccesoryPTD[playerid][20] = CreatePlayerTextDraw(playerid, 113.133300, 207.966720, "0");
	BuyAccesoryPTD[playerid][21] = CreatePlayerTextDraw(playerid, 146.466659, 207.966720, "0");
	BuyAccesoryPTD[playerid][22] = CreatePlayerTextDraw(playerid, 46.866649, 243.744567, "0");
	BuyAccesoryPTD[playerid][23] = CreatePlayerTextDraw(playerid, 80.199981, 243.744567, "0");
	BuyAccesoryPTD[playerid][24] = CreatePlayerTextDraw(playerid, 113.133300, 243.744567, "0");
	BuyAccesoryPTD[playerid][25] = CreatePlayerTextDraw(playerid, 146.466659, 243.744567, "0");

	BuyAccesoryPTD[playerid][26] = CreatePlayerTextDraw(playerid, 53.017020 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");
	BuyAccesoryPTD[playerid][27] = CreatePlayerTextDraw(playerid, 64.216850 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");
	BuyAccesoryPTD[playerid][28] = CreatePlayerTextDraw(playerid, 75.416679 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");
	BuyAccesoryPTD[playerid][29] = CreatePlayerTextDraw(playerid, 86.816505 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");
	BuyAccesoryPTD[playerid][30] = CreatePlayerTextDraw(playerid, 98.016334 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");
	BuyAccesoryPTD[playerid][31] = CreatePlayerTextDraw(playerid, 109.21616 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");
	BuyAccesoryPTD[playerid][32] = CreatePlayerTextDraw(playerid, 120.41598 - ((11.199829+11.199829/1.25)/2), 255.592651, "LD_BEAT:chit");

	for (new td_id = 0; td_id < MAX_ACCESORY_BUY_MAX_ITEMS_PAGE; td_id++)
	{
		PlayerTextDrawTextSize(playerid, BuyAccesoryPTD[playerid][td_id], 31.000000, 34.000000);
		PlayerTextDrawAlignment(playerid, BuyAccesoryPTD[playerid][td_id], 1);
		PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][td_id], -1);
		PlayerTextDrawSetShadow(playerid, BuyAccesoryPTD[playerid][td_id], 0);
		PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][td_id], COLOR_SERVER);
		PlayerTextDrawFont(playerid, BuyAccesoryPTD[playerid][td_id], 5);
		PlayerTextDrawSetProportional(playerid, BuyAccesoryPTD[playerid][td_id], 0);
		PlayerTextDrawSetSelectable(playerid, BuyAccesoryPTD[playerid][td_id], true);
		PlayerTextDrawSetPreviewModel(playerid, BuyAccesoryPTD[playerid][td_id], 0);
		PlayerTextDrawSetPreviewRot(playerid, BuyAccesoryPTD[playerid][td_id], 0.000000, 0.000000, 0.000000, 100.000000);
		
		PlayerTextDrawLetterSize(playerid, BuyAccesoryPTD[playerid][td_id + 14], 0.175411, 0.759998);
		PlayerTextDrawAlignment(playerid, BuyAccesoryPTD[playerid][td_id + 14], 3);
		PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][td_id + 14], 255);
		PlayerTextDrawSetShadow(playerid, BuyAccesoryPTD[playerid][td_id + 14], 0);
		PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][td_id + 14], 255);
		PlayerTextDrawFont(playerid, BuyAccesoryPTD[playerid][td_id + 14], 1);
		PlayerTextDrawSetProportional(playerid, BuyAccesoryPTD[playerid][td_id + 14], 1);

		if (td_id >= MAX_ACCESORY_BUY_MAX_PAGE) continue;

		PlayerTextDrawTextSize(playerid, BuyAccesoryPTD[playerid][td_id + 26], 12.000000, 12.000000);
		PlayerTextDrawAlignment(playerid, BuyAccesoryPTD[playerid][td_id + 26], 1);
		PlayerTextDrawSetShadow(playerid, BuyAccesoryPTD[playerid][td_id + 26], 0);
		PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][td_id + 26], 255);
		PlayerTextDrawFont(playerid, BuyAccesoryPTD[playerid][td_id + 26], 4);
		PlayerTextDrawSetProportional(playerid, BuyAccesoryPTD[playerid][td_id + 26], 0);
		PlayerTextDrawSetSelectable(playerid, BuyAccesoryPTD[playerid][td_id + 26], true);
	}
	BuyAccesoryPTD[playerid][33] = CreatePlayerTextDraw(playerid, 57.916667, 284.148101, "particle:lamp_shad_64");
	PlayerTextDrawTextSize(playerid, BuyAccesoryPTD[playerid][13], 51.000000, 16.000000);
	PlayerTextDrawAlignment(playerid, BuyAccesoryPTD[playerid][33], 1);
	PlayerTextDrawColor(playerid, BuyAccesoryPTD[playerid][33], -120);
	PlayerTextDrawSetShadow(playerid, BuyAccesoryPTD[playerid][33], 0);
	PlayerTextDrawBackgroundColor(playerid, BuyAccesoryPTD[playerid][33], 0);
	PlayerTextDrawFont(playerid, BuyAccesoryPTD[playerid][33], 4);
	PlayerTextDrawSetProportional(playerid, BuyAccesoryPTD[playerid][33], 0);

	for (new td_id = 0; td_id < sizeof (BuyAccesoryTD); td_id++) TextDrawShowForPlayer(playerid, BuyAccesoryTD[td_id]);
	for (new td_id = 0; td_id < sizeof (BuyAccesoryPTD[]); td_id++) PlayerTextDrawShow(playerid, BuyAccesoryPTD[playerid][td_id]);

	pTemp[playerid][tAccesoryBuyType] = TYPE_ITEMS_COMMON;
	pTemp[playerid][tAccesoryBuyPage] = 0;
	UpdateAccesoryBuyMenuPage(playerid);
	SelectTextDraw(playerid, 0xFF7F50FF);

	TogglePlayerControllable(playerid, false);
	SetCameraBehindPlayer(playerid);
	
	new id = pTemp[playerid][tBusinessID];
	if (BusinessInfo[id][bType] == BUSINESS_TYPE_VICTIM)
	{
		SetPlayerPosAC(playerid, 222.3489, -8.5845, 1002.2109, playerid, 5);
		SetPlayerFacingAngle(playerid, 266.7302);
		SetPlayerCameraPos(playerid, 225.3489, -8.5845, 1002.2109);
		SetPlayerCameraLookAt(playerid, 222.3489, -8.5845, 1002.2109);
	}
	else if (BusinessInfo[id][bType] == BUSINESS_TYPE_ZIP)
	{
		SetPlayerPosAC(playerid, 176.6238, -72.6065, 1001.8047, playerid, 18); 
		SetPlayerFacingAngle(playerid,85.0518); 
		SetPlayerCameraPos(playerid, 171.7000,-72.6568,1001.8047);
		SetPlayerCameraLookAt(playerid, 176.6238,-72.6065,1001.8047);
	}  
	else if (BusinessInfo[id][bType] == BUSINESS_TYPE_PROLAPS)
	{
		SetPlayerPosAC(playerid, 199.0974, -127.3947, 1003.5152, playerid, 3); 
		SetPlayerFacingAngle(playerid, 176.2323);
		SetPlayerCameraPos(playerid, 199.2118,-131.6095,1003.5152);
		SetPlayerCameraLookAt(playerid, 199.0974,-127.3947,1003.5152);  
	}
	return pTemp[playerid][tAccesoryBuyMenuShowed] = true;
}

stock CreateAccesoryBuyTD()
{
	BuyAccesoryTD[0] = TextDrawCreate(10.000000, 130.000000, "LD_BEAT:chit");
	BuyAccesoryTD[1] = TextDrawCreate(128.60000, 130.000000, "LD_BEAT:chit");
	BuyAccesoryTD[2] = TextDrawCreate(10.000000, 260.000000, "LD_BEAT:chit");
	BuyAccesoryTD[3] = TextDrawCreate(128.60000, 260.000000, "LD_BEAT:chit");

	BuyAccesoryTD[4] = TextDrawCreate(21.249979, 133.796188, "LD_SPAC:white");
	TextDrawTextSize(BuyAccesoryTD[4], 120.000000, 146.129928);
	TextDrawColor(BuyAccesoryTD[4], COLOR_SERVER);
	BuyAccesoryTD[5] = TextDrawCreate(13.749979, 141.955490, "LD_SPAC:white");
	TextDrawTextSize(BuyAccesoryTD[5], 135.000000, 130.941131);
	TextDrawColor(BuyAccesoryTD[5], 505290495);

	BuyAccesoryTD[6] = TextDrawCreate(80.833290, 134.081573, "SELECT ACCESORY");
	TextDrawLetterSize(BuyAccesoryTD[6], 0.173748, 0.848146);
	TextDrawTextSize(BuyAccesoryTD[6], 0.000000, 110.000000);
	TextDrawAlignment(BuyAccesoryTD[6], 2);
	TextDrawColor(BuyAccesoryTD[6], -1);
	TextDrawSetShadow(BuyAccesoryTD[6], 0);
	TextDrawBackgroundColor(BuyAccesoryTD[6], 255);
	TextDrawFont(BuyAccesoryTD[6], 1);
	TextDrawSetProportional(BuyAccesoryTD[6], 1);

	BuyAccesoryTD[7] = TextDrawCreate(21.250000, 283.333343, "bg_keys");
	TextDrawLetterSize(BuyAccesoryTD[7], 0.000000, 1.958333);
	TextDrawTextSize(BuyAccesoryTD[7], 142.000000, 0.000000);
	TextDrawAlignment(BuyAccesoryTD[7], 1);
	TextDrawColor(BuyAccesoryTD[7], -1);
	TextDrawUseBox(BuyAccesoryTD[7], 1);
	TextDrawBoxColor(BuyAccesoryTD[7], 505290361);
	TextDrawSetShadow(BuyAccesoryTD[7], 0);
	TextDrawBackgroundColor(BuyAccesoryTD[7], 255);
	TextDrawFont(BuyAccesoryTD[7], 1);
	TextDrawSetProportional(BuyAccesoryTD[7], 1);

	BuyAccesoryTD[8] = TextDrawCreate(21.200000, 283.000000, "LD_SPAC:white"); // click EXIT
	TextDrawTextSize(BuyAccesoryTD[8], 36.000000, 18.000000);
	TextDrawColor(BuyAccesoryTD[8], -1523963170);
	BuyAccesoryTD[9] = TextDrawCreate(109.000000, 283.000000, "LD_SPAC:white"); // click BUY
	TextDrawTextSize(BuyAccesoryTD[9], 33.000000, 18.000000);
	TextDrawColor(BuyAccesoryTD[9], 8388830);

	BuyAccesoryTD[10] = TextDrawCreate(39.583332, 287.144531, "EXIT");
	BuyAccesoryTD[11] = TextDrawCreate(125.833312, 287.144531, "BUY");

	BuyAccesoryTD[12] = TextDrawCreate(20.000001, 284.348114, "particle:lamp_shad_64");
	TextDrawTextSize(BuyAccesoryTD[12], 39.000000, 15.889997);
	BuyAccesoryTD[13] = TextDrawCreate(107.249977, 284.029602, "particle:lamp_shad_64");
	TextDrawTextSize(BuyAccesoryTD[13], 36.000000, 16.000000);

	for (new td_id = 0; td_id < 4; td_id++)
	{
		TextDrawTextSize(BuyAccesoryTD[td_id], 24.000000, 24.000000);
		TextDrawAlignment(BuyAccesoryTD[td_id], 1);
		TextDrawColor(BuyAccesoryTD[td_id], COLOR_SERVER);
		TextDrawSetShadow(BuyAccesoryTD[td_id], 0);
		TextDrawBackgroundColor(BuyAccesoryTD[td_id], 255);
		TextDrawFont(BuyAccesoryTD[td_id], 4);
		TextDrawSetProportional(BuyAccesoryTD[td_id], 0);

		if (td_id >= 2) continue;
		TextDrawAlignment(BuyAccesoryTD[td_id + 4], 1);
		TextDrawSetShadow(BuyAccesoryTD[td_id + 4], 0);
		TextDrawBackgroundColor(BuyAccesoryTD[td_id + 4], 255);
		TextDrawFont(BuyAccesoryTD[td_id + 4], 4);
		TextDrawSetProportional(BuyAccesoryTD[td_id + 4], 0);

		TextDrawAlignment(BuyAccesoryTD[td_id + 8], 1);
		TextDrawSetShadow(BuyAccesoryTD[td_id + 8], 0);
		TextDrawBackgroundColor(BuyAccesoryTD[td_id + 8], 255);
		TextDrawFont(BuyAccesoryTD[td_id + 8], 4);
		TextDrawSetProportional(BuyAccesoryTD[td_id + 8], 0);
		TextDrawSetSelectable(BuyAccesoryTD[td_id + 8], true);

		TextDrawLetterSize(BuyAccesoryTD[td_id + 10], 0.234163, 1.019255);
		TextDrawAlignment(BuyAccesoryTD[td_id + 10], 2);
		TextDrawColor(BuyAccesoryTD[td_id + 10], -1);
		TextDrawSetShadow(BuyAccesoryTD[td_id + 10], 0);
		TextDrawBackgroundColor(BuyAccesoryTD[td_id + 10], 255);
		TextDrawFont(BuyAccesoryTD[td_id + 10], 1);
		TextDrawSetProportional(BuyAccesoryTD[td_id + 10], 1);

		TextDrawAlignment(BuyAccesoryTD[td_id + 12], 1);
		TextDrawColor(BuyAccesoryTD[td_id + 12], -120);
		TextDrawSetShadow(BuyAccesoryTD[td_id + 12], 0);
		TextDrawBackgroundColor(BuyAccesoryTD[td_id + 12], 0);
		TextDrawFont(BuyAccesoryTD[td_id + 12], 4);
		TextDrawSetProportional(BuyAccesoryTD[td_id + 12], 0);
	}
}