

//=============================================================== [  ]

#define     SUBWAY_STATION_INT                  1
#define     SUBWAY_CARRIAGE_INT                 2
#define     SUBWAY_MAX_STATIONS                 13
#define     SUBWAY_TIME_TO_STOP                 20000
#define     SUBWAY_TIME_BETWEEN_STATIONS        30000

//=============================================================== [  ]

static const Float:subway_enter_pos[SUBWAY_MAX_STATIONS][3] = {
    {2236.1567, -1149.9158, 25.8463}, //Jefferson
    {2579.3916, -1285.1732, 46.1298}, //East Side
    {2653.6194, -1645.6781, 10.8678}, //LS Forum
    {2305.3401, -1983.0096, 13.5649}, //Willowfield
    {2235.6792, -1742.2646, 13.5520}, //Idelwood
    {1810.0012, -1821.6249, 13.5530}, //Unity
    {1571.7236, -2238.9316, 13.5485}, //Airport
    {935.0238, -1754.1115, 13.5469}, //Verona beach
    {429.5038, -1785.4979, 5.5399}, //Santa maria beach
    {520.0120, -1449.5282, 15.1568}, //Rodeo
    {1253.5936, -1416.6307, 13.6182}, //Market square
    {1553.4489, -1150.5819, 24.0781}, //Commercial
    {1968.5061, -1271.5735, 23.9908} //Glen park
};

static const Float:subway_exit_pos[SUBWAY_MAX_STATIONS][4] = {
    {2236.2688, -1146.4760, 25.7969, 360.0}, //Jefferson
    {2576.4104, -1285.3763, 46.1328, 90.0}, //East Side
    {2650.5759, -1645.9066, 10.8672, 90.0}, //LS Forum
    {2305.2061, -1980.1873, 13.5767, 0.0}, //Willowfield
    {2232.1416, -1742.3196, 13.5529, 90.0}, //Idelwood
    {1810.0250, -1824.7222, 13.5703, 180.0}, //Unity
    {1574.7732, -2238.8022, 13.5533, 270.0}, //Airport
    {935.3206, -1751.0288, 13.5469, 360.0}, //Verona beach
    {429.3599, -1782.0105, 5.5469, 0.0}, //Santa maria beach
    {520.1322, -1453.2109, 15.1461, 180.0}, //Rodeo
    {1253.4927, -1413.4766, 13.3611, 0.0}, //Market square
    {1553.6239, -1153.5643, 24.0781, 180.0}, //Commercial
    {1968.3492, -1268.1188, 23.9844, 0.0} //Glen park
};

static const subway_station_name[SUBWAY_MAX_STATIONS][] = {
    "Jefferson",
    "East Side",
    "Los Angeles Forum",
    "Willowfield",
    "Idelwood",
    "Unity",
    "Airport",
    "Verona beach",
    "Santa Maria beach",
    "Rodeo",
    "Market square",
    "Commercial",
    "Glen Park"
};

new 
	Iterator:PlayersInSubway<MAX_PLAYERS>,
	subway_carriage_checkpoint[6],
    subway_station_checkpoint[3],
    subway_enter_pickup[SUBWAY_MAX_STATIONS],
	subway_train_ongoing,
    subway_first_train_station,
    subway_second_train_station,
    subway_station_nameobj,  
	subway_player_stage[MAX_PLAYERS],
    bool:subway_player_train_info[MAX_PLAYERS] = {false, ...},
	bool:playertextdraw_on_screen[MAX_PLAYERS] = {false, ...},
    PlayerText:subway_ticket_PTD[MAX_PLAYERS][29],
    PlayerText:subway_map_PTD[MAX_PLAYERS][37]
;

//=============================================================== [  ]

subway_OnGameModeInit()
{
    LoadSubwayMapping();
    LoadSubwayResources();
    Iter_Clear(PlayersInSubway);
    subway_train_ongoing = 0;
    subway_first_train_station = 1;
    subway_second_train_station = 1;
    SetTimer("@__TrainTimer", SUBWAY_TIME_TO_STOP, false);
    return 0;
}

subway_OnPlayerInteriorChange(playerid, newinteriorid, oldinteriorid)
{
    if(newinteriorid == SUBWAY_STATION_INT)
    {
        new subway_station_vw = GetPlayerVirtualWorld(playerid);
        switch(subway_station_vw)
        {
            case 1..14: 
            {
                new string[27];
                format(string, sizeof(string), "%s\nstation", subway_station_name[subway_station_vw-1]);
                subway_station_nameobj = CreateDynamicObject(19477, 259.828643, 2521.780761, 19.919418, 0.000000, 0.000000, 270.000000, -1, -1, -1, 150.00, 150.00); 
                SetDynamicObjectMaterialText(subway_station_nameobj, 0, string, 130, "Engravers MT", 30, 1, 0xFF000000, 0x00000000, 1);
            }
        }
    }
    if(oldinteriorid == SUBWAY_STATION_INT)
    {
        DestroyDynamicObject(subway_station_nameobj);
        subway_station_nameobj = -1;
    }
    return 0;
}

subway_OnPlayerKeyStateChange(playerid, newkeys, oldkeys)
{
	#pragma unused oldkeys
    if(newkeys & KEY_WALK)
    {
        for(new i; i < SUBWAY_MAX_STATIONS; i++)
        {
            if(IsPlayerInRangeOfPoint(playerid, 1.0, 
                subway_enter_pos[i][0], subway_enter_pos[i][1], subway_enter_pos[i][2]))
            {
                SetPlayerInterior(playerid, SUBWAY_STATION_INT);
                SetPlayerVirtualWorld(playerid, i+1);
                SetPlayerPos(playerid, 209.7349, 2503.7307, 22.1556);
                SetPlayerFacingAngle(playerid, 180.0);
                switch(random(5))
                {
                    case 0: InterpolateCameraPos(playerid, 270.409790, 2513.493896, 18.998056, 272.654479, 2516.907958, 20.348920, 3500),
                                InterpolateCameraLookAt(playerid, 266.419738, 2516.411621, 18.245458, 269.933685, 2512.786132, 19.569301, 3500);
                    case 1: InterpolateCameraPos(playerid, 281.050903, 2512.497802, 17.862794, 252.428115, 2515.493408, 20.213203, 3500),
                                InterpolateCameraLookAt(playerid, 276.485137, 2514.535888, 17.845958, 256.183227, 2518.680664, 19.353012, 3500);
                    case 2: InterpolateCameraPos(playerid, 234.020111, 2519.345947, 18.639947, 280.452423, 2519.249755, 19.101739, 3500),
                                InterpolateCameraLookAt(playerid, 238.161727, 2516.559082, 18.923742, 275.549316, 2518.322998, 18.784337, 3500);
                    case 3: InterpolateCameraPos(playerid, 280.935546, 2511.589599, 19.109603, 234.268798, 2510.632812, 18.997627, 3500),
                                InterpolateCameraLookAt(playerid, 281.006927, 2516.585937, 18.928745, 234.040267, 2515.611572, 18.598403, 3500);
                    case 4: InterpolateCameraPos(playerid, 233.390304, 2519.613037, 22.276784, 268.461730, 2511.935546, 19.641492, 3500),
                                InterpolateCameraLookAt(playerid, 237.926788, 2517.775390, 21.255470, 265.178161, 2515.690429, 19.296806, 3500);
                }
                subway_player_stage[playerid] = 1;
                SetTimerEx("@__SubwayEnterExitTimer", 3500, false, "id", playerid);
            }
        }
        if(IsPlayerInRangeOfPoint(playerid, 1.0, 259.7442, 2521.4587, 17.8282))
        {
            new subway_station_vw = GetPlayerVirtualWorld(playerid);
            switch(subway_station_vw) 
            {
                case 1..14:
                {
                    SetPlayerInterior(playerid, 0);
                    SetPlayerVirtualWorld(playerid, 0);
                    SetPlayerPos(playerid, 
                        subway_exit_pos[subway_station_vw-1][0], 
                        subway_exit_pos[subway_station_vw-1][1], 
                        subway_exit_pos[subway_station_vw-1][2]);
                    SetPlayerFacingAngle(playerid, subway_exit_pos[subway_station_vw-1][3]);
                    SetCameraBehindPlayer(playerid);
                    if(Iter_Contains(PlayersInSubway, playerid))
                        Iter_Remove(PlayersInSubway, playerid);
                    DestroyDynamicObject(subway_station_nameobj);
                    subway_player_train_info[playerid] = false;
                }
            }
        }
        if(IsPlayerInRangeOfPoint(playerid, 1.0, 256.3398, 2520.6384, 17.8282))
        {
            CreateSubwayTicketTD(playerid);
            ShowSubwayTicketTD(playerid);
        }
        if(IsPlayerInRangeOfPoint(playerid, 1.0, 265.5544, 2521.4165, 17.8282))
        {
            new player_station = GetPlayerVirtualWorld(playerid);
            if(!Iter_Contains(PlayersInSubway, playerid))
            {
                SendClientMessage(playerid, COLOR_SERVER, "[] {FFFFFF}   \
                         .");
                return false;
            }
            if(player_station == subway_first_train_station ||
                player_station == subway_second_train_station)
            {
                SendClientMessage(playerid, COLOR_SERVER, "[] {FFFFFF}   \
                           .");
                return false;
            }
            CreateSubwayMapTD(playerid);
            UpdateSubwayMapTD(playerid);
            ShowSubwayMapTD(playerid);
        }
    }
    return 0;
}

subway_OnPlayerConnect(playerid)
{
    DestroySubwayTicketTD(playerid);
    DestroySubwayMapTD(playerid);
	return 0;
}

subway_OnPlayerClickTextDraw(playerid, Text:clickedid)
{
    if(playertextdraw_on_screen[playerid] == true)
    {
        if(clickedid == Text:INVALID_TEXT_DRAW) return SelectTextDraw(playerid, 0xF5F5DC11);
    }
    return 0;
}

subway_OnPlayerClickPTD(playerid, PlayerText:playertextid)
{
    if(playertextid == subway_ticket_PTD[playerid][17])
    {
        DestroySubwayTicketTD(playerid);
    }
    if(playertextid == subway_ticket_PTD[playerid][18])
    {
        Dialog_Show(playerid, "d_BUY_TICKET");
        DestroySubwayTicketTD(playerid);
    }
    if(playertextid == subway_ticket_PTD[playerid][19])
    {
		if(pInfo[playerid][pCash] < 1) return ErrorMessage(playerid, "   ");
        SendClientMessage(playerid, COLOR_SERVER, "[] {FFFFFF}   \
            "colserver" . {FFFFFF}     .");
        SendClientMessage(playerid, COLOR_SERVER, "[] {FFFFFF}  \
            "colserver"    . {FFFFFF}   ..");
        SendClientMessage(playerid, COLOR_SERVER, "[] {FFFFFF}..  \
              10  100      .");
		kLibGivePlayerMoney(playerid, -1, "metro");    
        Iter_Add(PlayersInSubway, playerid);
        DestroySubwayTicketTD(playerid);
        if(subway_player_train_info[playerid] == false)
        {
            SendClientMessage(playerid, COLOR_SERVER,
                "[] {FFFFFF}     .    \
                "colserver"~5 .");
            SendClientMessage(playerid, COLOR_SERVER,
                "[] {FFFFFF}       ,  \
                  .");
            subway_player_train_info[playerid] = true;
        }
    }
    if(playertextid == subway_map_PTD[playerid][17])
    {
        DestroySubwayMapTD(playerid);
    }
    return 0;
}

subway_OnPlayerEnterDynamicCP(playerid, STREAMER_TAG_CP:checkpointid)
{
    new player_station = GetPlayerVirtualWorld(playerid);
    for(new i; i < sizeof(subway_station_checkpoint); i++)
    {
        if(checkpointid == subway_station_checkpoint[i])
        {
            switch(random(6))
            {
                case 0: SetPlayerPos(playerid, 1924.9557, -2435.3298, 13.6391),
                    SetPlayerFacingAngle(playerid, 0.0);
                case 1: SetPlayerPos(playerid, 1919.9463, -2435.3303, 13.6391),
                    SetPlayerFacingAngle(playerid, 0.0);
                case 2: SetPlayerPos(playerid, 1915.0021, -2435.3296, 13.6391),
                    SetPlayerFacingAngle(playerid, 0.0);
                case 3: SetPlayerPos(playerid, 1915.0792, -2431.2566, 13.6391),
                    SetPlayerFacingAngle(playerid, 180.0);
                case 4: SetPlayerPos(playerid, 1920.0820, -2431.2566, 13.6391),
                    SetPlayerFacingAngle(playerid, 180.0);
                case 5: SetPlayerPos(playerid, 1925.0803, -2431.2566, 13.6391),
                    SetPlayerFacingAngle(playerid, 180.0);
            }
            if(player_station == subway_first_train_station) SetPlayerVirtualWorld(playerid, 1);
            if(player_station == subway_second_train_station) SetPlayerVirtualWorld(playerid, 2);
            SetPlayerInterior(playerid, SUBWAY_CARRIAGE_INT);
            SetCameraBehindPlayer(playerid);
            DestroyDynamicObject(subway_station_nameobj);
            subway_player_train_info[playerid] = false;
            DestroyStationCP();
            DestroyCarriageCP();
        }
    }
    for(new i; i < sizeof(subway_carriage_checkpoint); i++)
    {
        if(checkpointid == subway_carriage_checkpoint[i])
        {
            SetPlayerPos(playerid, 209.7349, 2503.7307, 22.1556);
            switch(random(5))
            {
                case 0: InterpolateCameraPos(playerid, 270.409790, 2513.493896, 18.998056, 272.654479, 2516.907958, 20.348920, 3500),
                            InterpolateCameraLookAt(playerid, 266.419738, 2516.411621, 18.245458, 269.933685, 2512.786132, 19.569301, 3500);
                case 1: InterpolateCameraPos(playerid, 281.050903, 2512.497802, 17.862794, 252.428115, 2515.493408, 20.213203, 3500),
                            InterpolateCameraLookAt(playerid, 276.485137, 2514.535888, 17.845958, 256.183227, 2518.680664, 19.353012, 3500);
                case 2: InterpolateCameraPos(playerid, 234.020111, 2519.345947, 18.639947, 280.452423, 2519.249755, 19.101739, 3500),
                            InterpolateCameraLookAt(playerid, 238.161727, 2516.559082, 18.923742, 275.549316, 2518.322998, 18.784337, 3500);
                case 3: InterpolateCameraPos(playerid, 280.935546, 2511.589599, 19.109603, 234.268798, 2510.632812, 18.997627, 3500),
                            InterpolateCameraLookAt(playerid, 281.006927, 2516.585937, 18.928745, 234.040267, 2515.611572, 18.598403, 3500);
                case 4: InterpolateCameraPos(playerid, 233.390304, 2519.613037, 22.276784, 268.461730, 2511.935546, 19.641492, 3500),
                            InterpolateCameraLookAt(playerid, 237.926788, 2517.775390, 21.255470, 265.178161, 2515.690429, 19.296806, 3500);
            }
            if(GetPlayerVirtualWorld(playerid) == 1)
            {
                switch(subway_first_train_station)
                {
                    case 1..14: SetPlayerVirtualWorld(playerid, subway_first_train_station);
                }
            }
            if(GetPlayerVirtualWorld(playerid) == 2)
            {
                switch(subway_second_train_station)
                {
                    case 1..14: SetPlayerVirtualWorld(playerid, subway_second_train_station);
                }
            }
            SetPlayerInterior(playerid, SUBWAY_STATION_INT);
            DestroyStationCP();
            DestroyCarriageCP();
            subway_player_stage[playerid] = 2;
            SetTimerEx("@__SubwayEnterExitTimer", 3500, false, "id", playerid);
        }
    }
    return 0;
}

subway_OnPlayerDisconnect(playerid, reason)
{
	#pragma unused reason
    if(Iter_Contains(PlayersInSubway, playerid))
        Iter_Remove(PlayersInSubway, playerid);
	SavePlayerInteger(playerid, "stickets", pInfo[playerid][stickets]);
    DestroyDynamicObject(subway_station_nameobj);
    subway_station_nameobj = -1;
    DestroyStationCP();
    DestroyCarriageCP();
    pInfo[playerid][stickets] = -1;
    playertextdraw_on_screen[playerid] = false;
    subway_player_train_info[playerid] = false;
    DestroySubwayTicketTD(playerid);
    DestroySubwayMapTD(playerid);
    return 0;
}

//=============================================================== [  ]

forward @__SubwayEnterExitTimer(playerid);
@__SubwayEnterExitTimer(playerid)
{
    if(subway_player_stage[playerid] == 1)
    {
        SetPlayerPos(playerid, 259.7811, 2519.2944, 17.8282);
        SetPlayerFacingAngle(playerid, 180.0);
        SetCameraBehindPlayer(playerid);
        if(pInfo[playerid][stickets] > 0)
        {
            pInfo[playerid][stickets] --;
            new string[126];
            format(string, sizeof(string), "[] {FFFFFF}    \
             .  : "colserver"%d.", pInfo[playerid][stickets]);
            SendClientMessage(playerid, COLOR_SERVER, string);
            Iter_Add(PlayersInSubway, playerid);
            if(subway_player_train_info[playerid] == false)
            {
                SendClientMessage(playerid, COLOR_SERVER,
                    "[] {FFFFFF}     .    \
                    "colserver"~5 .");
                SendClientMessage(playerid, COLOR_SERVER,
                    "[] {FFFFFF}       ,  \
                      .");
                subway_player_train_info[playerid] = true;
            }
        } 
        else SendClientMessage(playerid, COLOR_SERVER,
            "[] {FFFFFF}   ,   .  \
                .");
    }
    if(subway_player_stage[playerid] == 2)
    {
        switch(random(3))
        {
            case 0: SetPlayerPos(playerid, 267.4076, 2512.2788, 17.8345);
            case 1: SetPlayerPos(playerid, 255.2371, 2512.4978, 17.8282);
            case 2: SetPlayerPos(playerid, 243.1399, 2512.5588, 17.8282);
        }
        SetPlayerFacingAngle(playerid, 0.0);
        SetCameraBehindPlayer(playerid);
    }
    return true;
}

forward @__TrainTimer();
@__TrainTimer()
{
    if(subway_train_ongoing == 1) 
    {
        subway_train_ongoing = 0;
        SetTimer("@__TrainTimer", SUBWAY_TIME_TO_STOP, false);
        foreach(new i: PlayersInSubway)
        {
            new player_interior = GetPlayerInterior(i);
            new player_virtualworld = GetPlayerVirtualWorld(i);
            if(player_interior == SUBWAY_STATION_INT)
            {
                switch(player_virtualworld)
                {
                    case 1..14:
                    {
                        if(player_virtualworld == subway_first_train_station || 
                            player_virtualworld == subway_second_train_station)
                        {    
                            new string[137];
                            format(string, sizeof(string), 
                                "[SUBWAY] {FFFFFF}  {6496ED}\"%s\" {FFFFFF} . \
                                  .", 
                                subway_station_name[player_virtualworld-1]);
                            SendClientMessage(i, COLOR_SERVER, string);
                            Dialog_Show(i, "d_TRAIN_ARRIVE");
                            CreateStationCP(i, player_virtualworld);							
                            return true;
                        }
                    }
                }
            }
            if(player_interior == SUBWAY_CARRIAGE_INT &&
                player_virtualworld == 1)
            {
                switch(subway_first_train_station)
                {
                    case 1..14:
                    {
                        CreateCarriageCP(i, player_virtualworld);
                        new string[143];
                        format(string, sizeof(string), 
                            "[SUBWAY] {FFFFFF} {6496ED}\"%s\" {FFFFFF}  \
                                 .", 
                            subway_station_name[subway_first_train_station-1]);
                        SendClientMessage(i, COLOR_SERVER, string);
                    }
                }
            }
            if(player_interior == SUBWAY_CARRIAGE_INT &&
                player_virtualworld == 2)
            {
                switch(subway_second_train_station)
                {
                    case 1..14:
                    {
                        CreateCarriageCP(i, player_virtualworld);
                        new string[143];
                        format(string, sizeof(string), 
                            "[SUBWAY] {FFFFFF} {6496ED}\"%s\" {FFFFFF}  \
                                 .", 
                            subway_station_name[subway_second_train_station-1]);
                        SendClientMessage(i, COLOR_SERVER, string);
                    }
                }
            }
        }
    }
    else 
    {
        subway_train_ongoing = 1;
        subway_first_train_station ++;
        if(subway_first_train_station >= 15) subway_first_train_station = 1;
        subway_second_train_station --;
        if(subway_second_train_station <= 0) subway_second_train_station = 14;
        SetTimer("@__TrainTimer", SUBWAY_TIME_BETWEEN_STATIONS, false);
        foreach(new i: PlayersInSubway)
        {
            new player_interior = GetPlayerInterior(i);
            new player_virtualworld = GetPlayerVirtualWorld(i);
            if(player_interior == SUBWAY_CARRIAGE_INT &&
                player_virtualworld == 1)
            {
                switch(subway_first_train_station)
                {
                    case 1..14:
                    {
                        new string[95];
                        format(string, sizeof(string), 
                            "[SUBWAY] {FFFFFF},  !   - {6496ED}\"%s\"", 
                            subway_station_name[subway_first_train_station-1]);
                        SendClientMessage(i, COLOR_SERVER, string);
                    }
                }
            }
            if(player_interior == SUBWAY_CARRIAGE_INT &&
                player_virtualworld == 2)
            {
                switch(subway_second_train_station)
                {
                    case 1..14:
                    {
                        new string[95];
                        format(string, sizeof(string), 
                            "[SUBWAY] {FFFFFF},  !   - {6496ED}\"%s\"", 
                            subway_station_name[subway_second_train_station-1]);
                        SendClientMessage(i, COLOR_SERVER, string);
                    }
                }
            }
        }
        DestroyStationCP();
        DestroyCarriageCP();
    }
    return true;
}

//=============================================================== [  ]

stock ShowSubwayMapTD(playerid)
{
    for(new i; i < sizeof(subway_map_PTD[]); i++)
        PlayerTextDrawShow(playerid, subway_map_PTD[playerid][i]);
    SelectTextDraw(playerid, 0xFFFFFF11);
    playertextdraw_on_screen[playerid] = true;
}

stock UpdateSubwayMapTD(playerid)
{
    new player_station = GetPlayerVirtualWorld(playerid);
    PlayerTextDrawDestroy(playerid, subway_map_PTD[playerid][34]);
    PlayerTextDrawDestroy(playerid, subway_map_PTD[playerid][35]);
    PlayerTextDrawDestroy(playerid, subway_map_PTD[playerid][36]);
    switch(player_station)
    {
        case 1:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 367.00, 207.00, "you_here");
        case 2:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 397.00, 215.00, "you_here");
        case 3:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 397.00, 234.00, "you_here");
        case 4:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 375.00, 253.00, "you_here");
        case 5:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 367.00, 240.00, "you_here");
        case 6:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 337.00, 244.00, "you_here");
        case 7:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 321.00, 268.00, "you_here");
        case 8:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 310.00, 238.00, "you_here");
        case 9:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 274.00, 240.00, "you_here");
        case 10:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 238.00, 241.00, "you_here");
        case 11:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 244.00, 224.00, "you_here");
        case 12:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 296.00, 221.00, "you_here");
        case 13:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 321.00, 207.00, "you_here");
        case 14:
            subway_map_PTD[playerid][34] = CreatePlayerTextDraw(playerid, 350.00, 224.00, "you_here");
    }
    PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][34], 0.1589, 1.0678);
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][34], 0.0000, 295.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][34], 2);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][34], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][34], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][34], 2);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][34], 1);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][34], 0);

    if(subway_first_train_station == subway_second_train_station)
    {
        if(subway_first_train_station == 1)
        {
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 367.00, 207.00, "train_1");
            PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][35], 0.1589, 1.0678);
            PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][35], 0.0000, 295.0000);
            PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][35], 2);
            PlayerTextDrawColor(playerid, subway_map_PTD[playerid][35], 255);
            PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][35], 255);
            PlayerTextDrawFont(playerid, subway_map_PTD[playerid][35], 2);
            PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][35], 1);
            PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][35], 0);

            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 367.00, 217.00, "train_2");
            PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][36], 0.1589, 1.0678);
            PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][36], 0.0000, 295.0000);
            PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][36], 2);
            PlayerTextDrawColor(playerid, subway_map_PTD[playerid][36], 255);
            PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][36], 255);
            PlayerTextDrawFont(playerid, subway_map_PTD[playerid][36], 2);
            PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][36], 1);
            PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][36], 0);

            PlayerTextDrawShow(playerid, subway_map_PTD[playerid][34]);
            PlayerTextDrawShow(playerid, subway_map_PTD[playerid][35]);
            PlayerTextDrawShow(playerid, subway_map_PTD[playerid][36]);
            return false;
        }
        if(subway_first_train_station == 8)
        {
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 310.00, 238.00, "train_1");
            PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][35], 0.1589, 1.0678);
            PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][35], 0.0000, 295.0000);
            PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][35], 2);
            PlayerTextDrawColor(playerid, subway_map_PTD[playerid][35], 255);
            PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][35], 255);
            PlayerTextDrawFont(playerid, subway_map_PTD[playerid][35], 2);
            PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][35], 1);
            PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][35], 0);

            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 310.00, 248.00, "train_2");
            PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][36], 0.1589, 1.0678);
            PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][36], 0.0000, 295.0000);
            PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][36], 2);
            PlayerTextDrawColor(playerid, subway_map_PTD[playerid][36], 255);
            PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][36], 255);
            PlayerTextDrawFont(playerid, subway_map_PTD[playerid][36], 2);
            PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][36], 1);
            PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][36], 0);

            PlayerTextDrawShow(playerid, subway_map_PTD[playerid][34]);
            PlayerTextDrawShow(playerid, subway_map_PTD[playerid][35]);
            PlayerTextDrawShow(playerid, subway_map_PTD[playerid][36]);
            return false;
        }
        return false;
    }

    switch(subway_first_train_station)
    {
        case 1:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 367.00, 207.00, "train_1");
        case 2:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 397.00, 215.00, "train_1");
        case 3:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 397.00, 234.00, "train_1");
        case 4:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 375.00, 253.00, "train_1");
        case 5:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 367.00, 240.00, "train_1");
        case 6:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 337.00, 244.00, "train_1");
        case 7:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 321.00, 268.00, "train_1");
        case 8:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 310.00, 238.00, "train_1");
        case 9:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 274.00, 240.00, "train_1");
        case 10:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 238.00, 241.00, "train_1");
        case 11:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 244.00, 224.00, "train_1");
        case 12:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 296.00, 221.00, "train_1");
        case 13:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 321.00, 207.00, "train_1");
        case 14:
            subway_map_PTD[playerid][35] = CreatePlayerTextDraw(playerid, 350.00, 224.00, "train_1");
    }
    PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][35], 0.1589, 1.0678);
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][35], 0.0000, 295.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][35], 2);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][35], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][35], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][35], 2);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][35], 1);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][35], 0);

    switch(subway_second_train_station)
    {
        case 1:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 367.00, 207.00, "train_2");
        case 2:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 397.00, 215.00, "train_2");
        case 3:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 397.00, 234.00, "train_2");
        case 4:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 375.00, 253.00, "train_2");
        case 5:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 367.00, 240.00, "train_2");
        case 6:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 337.00, 244.00, "train_2");
        case 7:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 321.00, 268.00, "train_2");
        case 8:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 310.00, 238.00, "train_2");
        case 9:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 274.00, 240.00, "train_2");
        case 10:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 238.00, 241.00, "train_2");
        case 11:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 244.00, 224.00, "train_2");
        case 12:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 296.00, 221.00, "train_2");
        case 13:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 321.00, 207.00, "train_2");
        case 14:
            subway_map_PTD[playerid][36] = CreatePlayerTextDraw(playerid, 350.00, 224.00, "train_2");
    }
    PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][36], 0.1589, 1.0678);
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][36], 0.0000, 295.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][36], 2);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][36], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][36], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][36], 2);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][36], 1);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][36], 0);

    PlayerTextDrawShow(playerid, subway_map_PTD[playerid][34]);
    PlayerTextDrawShow(playerid, subway_map_PTD[playerid][35]);
    PlayerTextDrawShow(playerid, subway_map_PTD[playerid][36]);
    return true;
}

stock DestroySubwayMapTD(playerid)
{
    for(new i; i < sizeof(subway_map_PTD[]); i++)
        PlayerTextDrawDestroy(playerid, subway_map_PTD[playerid][i]),
        subway_map_PTD[playerid][i] = PlayerText:-1;
    CancelSelectTextDraw(playerid);
    playertextdraw_on_screen[playerid] = false;
}

stock CreateSubwayMapTD(playerid)
{
    subway_map_PTD[playerid][0] = CreatePlayerTextDraw(playerid, 207.0000, 134.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][0], 215.0000, 215.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][0], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][0], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][0], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][0], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][0], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][0], 0);

    subway_map_PTD[playerid][1] = CreatePlayerTextDraw(playerid, 196.0000, 130.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][1], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][1], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][1], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][1], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][1], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][1], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][1], 0);

    subway_map_PTD[playerid][2] = CreatePlayerTextDraw(playerid, 409.0000, 130.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][2], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][2], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][2], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][2], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][2], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][2], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][2], 0);

    subway_map_PTD[playerid][3] = CreatePlayerTextDraw(playerid, 196.0000, 330.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][3], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][3], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][3], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][3], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][3], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][3], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][3], 0);

    subway_map_PTD[playerid][4] = CreatePlayerTextDraw(playerid, 408.0000, 330.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][4], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][4], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][4], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][4], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][4], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][4], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][4], 0);

    subway_map_PTD[playerid][5] = CreatePlayerTextDraw(playerid, 200.0000, 141.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][5], 228.0000, 202.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][5], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][5], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][5], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][5], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][5], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][5], 0);

    subway_map_PTD[playerid][6] = CreatePlayerTextDraw(playerid, 198.0000, 132.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][6], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][6], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][6], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][6], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][6], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][6], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][6], 0);

    subway_map_PTD[playerid][7] = CreatePlayerTextDraw(playerid, 407.0000, 132.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][7], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][7], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][7], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][7], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][7], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][7], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][7], 0);

    subway_map_PTD[playerid][8] = CreatePlayerTextDraw(playerid, 198.0000, 328.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][8], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][8], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][8], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][8], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][8], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][8], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][8], 0);

    subway_map_PTD[playerid][9] = CreatePlayerTextDraw(playerid, 406.0000, 328.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][9], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][9], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][9], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][9], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][9], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][9], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][9], 0);

    subway_map_PTD[playerid][10] = CreatePlayerTextDraw(playerid, 208.0000, 136.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][10], 212.0000, 211.0305);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][10], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][10], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][10], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][10], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][10], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][10], 0);

    subway_map_PTD[playerid][11] = CreatePlayerTextDraw(playerid, 202.0000, 142.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][11], 224.0000, 198.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][11], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][11], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][11], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][11], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][11], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][11], 0);

    subway_map_PTD[playerid][12] = CreatePlayerTextDraw(playerid, 313.0000, 136.0000, "metro_map"); // 
    PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][12], 0.3233, 1.8516);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][12], 2);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][12], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][12], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][12], 2);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][12], 1);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][12], 0);

    subway_map_PTD[playerid][13] = CreatePlayerTextDraw(playerid, 243.0000, 153.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][13], 137.0000, 1.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][13], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][13], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][13], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][13], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][13], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][13], 0);

    subway_map_PTD[playerid][14] = CreatePlayerTextDraw(playerid, 341.0000, 322.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][14], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][14], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][14], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][14], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][14], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][14], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][14], 0);

    subway_map_PTD[playerid][15] = CreatePlayerTextDraw(playerid, 398.0000, 322.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][15], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][15], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][15], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][15], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][15], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][15], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][15], 0);

    subway_map_PTD[playerid][16] = CreatePlayerTextDraw(playerid, 351.0000, 326.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][16], 60.0000, 15.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][16], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][16], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][16], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][16], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][16], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][16], 0);

    subway_map_PTD[playerid][17] = CreatePlayerTextDraw(playerid, 382.0000, 328.0000, "close"); // 
    PlayerTextDrawLetterSize(playerid, subway_map_PTD[playerid][17], 0.3424, 1.2403);
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][17], 10.0000, 50.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][17], 2);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][17], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][17], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][17], 3);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][17], 1);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][17], 1);
    PlayerTextDrawSetSelectable(playerid, subway_map_PTD[playerid][17], true);

    subway_map_PTD[playerid][18] = CreatePlayerTextDraw(playerid, 206.0000, 155.0000, "samaps:gtasamapbit4"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][18], 216.0000, 164.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][18], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][18], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][18], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][18], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][18], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][18], 0);

    subway_map_PTD[playerid][19] = CreatePlayerTextDraw(playerid, 206.0000, 321.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][19], 216.0000, 1.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][19], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][19], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][19], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][19], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][19], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][19], 0);

    subway_map_PTD[playerid][20] = CreatePlayerTextDraw(playerid, 363.0000, 215.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][20], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][20], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][20], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][20], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][20], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][20], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][20], 0);

    subway_map_PTD[playerid][21] = CreatePlayerTextDraw(playerid, 394.0000, 223.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][21], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][21], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][21], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][21], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][21], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][21], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][21], 0);

    subway_map_PTD[playerid][22] = CreatePlayerTextDraw(playerid, 395.0000, 242.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][22], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][22], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][22], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][22], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][22], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][22], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][22], 0);

    subway_map_PTD[playerid][23] = CreatePlayerTextDraw(playerid, 371.0000, 261.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][23], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][23], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][23], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][23], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][23], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][23], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][23], 0);

    subway_map_PTD[playerid][24] = CreatePlayerTextDraw(playerid, 364.0000, 248.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][24], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][24], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][24], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][24], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][24], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][24], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][24], 0);

    subway_map_PTD[playerid][25] = CreatePlayerTextDraw(playerid, 334.0000, 252.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][25], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][25], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][25], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][25], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][25], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][25], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][25], 0);

    subway_map_PTD[playerid][26] = CreatePlayerTextDraw(playerid, 317.0000, 276.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][26], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][26], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][26], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][26], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][26], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][26], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][26], 0);

    subway_map_PTD[playerid][27] = CreatePlayerTextDraw(playerid, 306.0000, 246.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][27], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][27], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][27], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][27], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][27], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][27], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][27], 0);

    subway_map_PTD[playerid][28] = CreatePlayerTextDraw(playerid, 270.0000, 248.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][28], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][28], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][28], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][28], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][28], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][28], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][28], 0);

    subway_map_PTD[playerid][29] = CreatePlayerTextDraw(playerid, 234.0000, 249.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][29], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][29], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][29], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][29], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][29], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][29], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][29], 0);

    subway_map_PTD[playerid][30] = CreatePlayerTextDraw(playerid, 241.0000, 232.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][30], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][30], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][30], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][30], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][30], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][30], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][30], 0);

    subway_map_PTD[playerid][31] = CreatePlayerTextDraw(playerid, 293.0000, 229.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][31], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][31], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][31], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][31], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][31], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][31], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][31], 0);

    subway_map_PTD[playerid][32] = CreatePlayerTextDraw(playerid, 317.0000, 215.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][32], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][32], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][32], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][32], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][32], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][32], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][32], 0);

    subway_map_PTD[playerid][33] = CreatePlayerTextDraw(playerid, 347.0000, 222.0000, "hud:radar_light"); // 
    PlayerTextDrawTextSize(playerid, subway_map_PTD[playerid][33], 5.0000, 5.0000);
    PlayerTextDrawAlignment(playerid, subway_map_PTD[playerid][33], 1);
    PlayerTextDrawColor(playerid, subway_map_PTD[playerid][33], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_map_PTD[playerid][33], 255);
    PlayerTextDrawFont(playerid, subway_map_PTD[playerid][33], 4);
    PlayerTextDrawSetProportional(playerid, subway_map_PTD[playerid][33], 0);
    PlayerTextDrawSetShadow(playerid, subway_map_PTD[playerid][33], 0);
}

stock ShowSubwayTicketTD(playerid)
{
    for(new i; i < sizeof(subway_ticket_PTD[]); i++)
        PlayerTextDrawShow(playerid, subway_ticket_PTD[playerid][i]);
    SelectTextDraw(playerid, 0xFFFFFF11);
    playertextdraw_on_screen[playerid] = true;
}

stock DestroySubwayTicketTD(playerid)
{
    for(new i; i < sizeof(subway_ticket_PTD[]); i++)
        PlayerTextDrawDestroy(playerid, subway_ticket_PTD[playerid][i]),
        subway_ticket_PTD[playerid][i] = PlayerText:-1;
    CancelSelectTextDraw(playerid);
    playertextdraw_on_screen[playerid] = false;
}

stock CreateSubwayTicketTD(playerid)
{
    subway_ticket_PTD[playerid][0] = CreatePlayerTextDraw(playerid, 207.0000, 134.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][0], 215.0000, 215.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][0], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][0], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][0], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][0], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][0], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][0], 0);

    subway_ticket_PTD[playerid][1] = CreatePlayerTextDraw(playerid, 196.0000, 130.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][1], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][1], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][1], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][1], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][1], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][1], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][1], 0);

    subway_ticket_PTD[playerid][2] = CreatePlayerTextDraw(playerid, 409.0000, 130.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][2], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][2], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][2], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][2], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][2], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][2], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][2], 0);

    subway_ticket_PTD[playerid][3] = CreatePlayerTextDraw(playerid, 196.0000, 330.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][3], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][3], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][3], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][3], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][3], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][3], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][3], 0);

    subway_ticket_PTD[playerid][4] = CreatePlayerTextDraw(playerid, 408.0000, 330.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][4], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][4], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][4], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][4], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][4], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][4], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][4], 0);

    subway_ticket_PTD[playerid][5] = CreatePlayerTextDraw(playerid, 200.0000, 138.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][5], 228.0000, 202.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][5], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][5], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][5], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][5], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][5], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][5], 0);

    subway_ticket_PTD[playerid][6] = CreatePlayerTextDraw(playerid, 198.0000, 132.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][6], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][6], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][6], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][6], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][6], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][6], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][6], 0);

    subway_ticket_PTD[playerid][7] = CreatePlayerTextDraw(playerid, 407.0000, 132.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][7], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][7], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][7], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][7], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][7], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][7], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][7], 0);

    subway_ticket_PTD[playerid][8] = CreatePlayerTextDraw(playerid, 198.0000, 328.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][8], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][8], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][8], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][8], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][8], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][8], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][8], 0);

    subway_ticket_PTD[playerid][9] = CreatePlayerTextDraw(playerid, 406.0000, 328.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][9], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][9], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][9], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][9], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][9], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][9], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][9], 0);

    subway_ticket_PTD[playerid][10] = CreatePlayerTextDraw(playerid, 207.0000, 136.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][10], 214.0000, 211.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][10], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][10], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][10], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][10], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][10], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][10], 0);

    subway_ticket_PTD[playerid][11] = CreatePlayerTextDraw(playerid, 202.0000, 140.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][11], 224.0000, 202.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][11], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][11], 255);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][11], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][11], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][11], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][11], 0);

    subway_ticket_PTD[playerid][12] = CreatePlayerTextDraw(playerid, 313.0000, 136.0000, "m-ticket"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][12], 0.4564, 1.8986);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][12], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][12], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][12], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][12], 2);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][12], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][12], 0);

    subway_ticket_PTD[playerid][13] = CreatePlayerTextDraw(playerid, 243.0000, 153.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][13], 137.0000, 1.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][13], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][13], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][13], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][13], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][13], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][13], 0);

    subway_ticket_PTD[playerid][14] = CreatePlayerTextDraw(playerid, 341.0000, 322.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][14], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][14], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][14], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][14], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][14], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][14], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][14], 0);

    subway_ticket_PTD[playerid][15] = CreatePlayerTextDraw(playerid, 398.0000, 322.0000, "LD_BEAT:chit"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][15], 23.0000, 23.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][15], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][15], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][15], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][15], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][15], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][15], 0);

    subway_ticket_PTD[playerid][16] = CreatePlayerTextDraw(playerid, 351.0000, 326.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][16], 60.0000, 15.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][16], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][16], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][16], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][16], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][16], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][16], 0);

    subway_ticket_PTD[playerid][17] = CreatePlayerTextDraw(playerid, 382.0000, 328.0000, "close"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][17], 0.3424, 1.2406);
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][17], 10.0000, 50.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][17], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][17], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][17], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][17], 3);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][17], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][17], 1);
    PlayerTextDrawSetSelectable(playerid, subway_ticket_PTD[playerid][17], true);

    subway_ticket_PTD[playerid][18] = CreatePlayerTextDraw(playerid, 211.0000, 185.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][18], 90.0000, 90.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][18], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][18], -1061109505);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][18], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][18], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][18], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][18], 0);
    PlayerTextDrawSetSelectable(playerid, subway_ticket_PTD[playerid][18], true);

    subway_ticket_PTD[playerid][19] = CreatePlayerTextDraw(playerid, 328.0000, 185.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][19], 90.0000, 90.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][19], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][19], -1061109505);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][19], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][19], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][19], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][19], 0);
    PlayerTextDrawSetSelectable(playerid, subway_ticket_PTD[playerid][19], true);

    subway_ticket_PTD[playerid][20] = CreatePlayerTextDraw(playerid, 211.0000, 311.0000, "LD_SPAC:white"); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][20], 207.0000, 1.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][20], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][20], COLOR_SERVER);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][20], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][20], 4);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][20], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][20], 0);

    subway_ticket_PTD[playerid][21] = CreatePlayerTextDraw(playerid, 256.0000, 180.0000, "season_ticket"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][21], 0.3835, 1.2406);
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][21], 0.0000, 10.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][21], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][21], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][21], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][21], 3);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][21], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][21], 1);

    subway_ticket_PTD[playerid][22] = CreatePlayerTextDraw(playerid, 376.0000, 177.0000, "one-time~n~ticket"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][22], 0.3835, 1.2406);
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][22], 0.0000, 10.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][22], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][22], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][22], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][22], 3);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][22], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][22], 1);

    subway_ticket_PTD[playerid][23] = CreatePlayerTextDraw(playerid, 314.0000, 297.0000, "click_on_the_necessary_point_in_the_menu"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][23], 0.3274, 1.2313);
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][23], 0.0000, 10.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][23], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][23], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][23], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][23], 3);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][23], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][23], 1);

    subway_ticket_PTD[playerid][24] = CreatePlayerTextDraw(playerid, 210.0000, 183.4666, ""); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][24], 90.0000, 90.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][24], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][24], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][24], 0);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][24], 5);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][24], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][24], 0);
    PlayerTextDrawSetPreviewModel(playerid, subway_ticket_PTD[playerid][24], 1581);
    PlayerTextDrawSetPreviewRot(playerid, subway_ticket_PTD[playerid][24], 0.0000, 0.0000, 189.0000, 1.0641);

    subway_ticket_PTD[playerid][25] = CreatePlayerTextDraw(playerid, 331.0000, 190.0000, ""); // 
    PlayerTextDrawTextSize(playerid, subway_ticket_PTD[playerid][25], 90.0000, 90.0000);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][25], 1);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][25], 225);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][25], 0);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][25], 5);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][25], 0);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][25], 0);
    PlayerTextDrawSetPreviewModel(playerid, subway_ticket_PTD[playerid][25], 11736);
    PlayerTextDrawSetPreviewRot(playerid, subway_ticket_PTD[playerid][25], 90.0000, 180.0000, 90.0000, 0.9233);

    subway_ticket_PTD[playerid][26] = CreatePlayerTextDraw(playerid, 376.0000, 211.0000, "ticket"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][26], 0.4029, 1.2639);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][26], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][26], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][26], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][26], 0);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][26], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][26], 0);

    subway_ticket_PTD[playerid][27] = CreatePlayerTextDraw(playerid, 376.0000, 203.0000, "Subway"); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][27], 0.4029, 1.2639);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][27], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][27], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][27], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][27], 0);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][27], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][27], 0);

    new string[11];/*, day, mounth, year;
    getdate(year, mounth, day);*/
    format(string, sizeof(string), "%02d.%02d.%04d", day, month, year);

    subway_ticket_PTD[playerid][28] = CreatePlayerTextDraw(playerid, 376.0000, 257.0000, string); // 
    PlayerTextDrawLetterSize(playerid, subway_ticket_PTD[playerid][28], 0.2560, 0.8486);
    PlayerTextDrawAlignment(playerid, subway_ticket_PTD[playerid][28], 2);
    PlayerTextDrawColor(playerid, subway_ticket_PTD[playerid][28], -1);
    PlayerTextDrawBackgroundColor(playerid, subway_ticket_PTD[playerid][28], 255);
    PlayerTextDrawFont(playerid, subway_ticket_PTD[playerid][28], 0);
    PlayerTextDrawSetProportional(playerid, subway_ticket_PTD[playerid][28], 1);
    PlayerTextDrawSetShadow(playerid, subway_ticket_PTD[playerid][28], 0);
}

stock CreateStationCP(playerid, virtualworld)
{
    subway_station_checkpoint[0] = CreateDynamicCP(243.1873, 2510.3789, 17.8445, 2.0, 
        virtualworld, SUBWAY_STATION_INT, playerid, 50.0);
    subway_station_checkpoint[1] = CreateDynamicCP(255.2928, 2510.3799, 17.8445, 2.0, 
        virtualworld, SUBWAY_STATION_INT, playerid, 50.0);
    subway_station_checkpoint[2] = CreateDynamicCP(267.3849, 2510.3787, 17.8445, 2.0, 
        virtualworld, SUBWAY_STATION_INT, playerid, 50.0);
}

stock DestroyStationCP()
{
    for(new i; i < sizeof(subway_station_checkpoint); i++)
        DestroyDynamicCP(subway_station_checkpoint[i]),
        subway_station_checkpoint[i] = -1;
}

stock CreateCarriageCP(playerid, virtualworld)
{
    subway_carriage_checkpoint[0] = CreateDynamicCP(1924.9557, -2435.3298, 13.6391, 1.0, 
        virtualworld, SUBWAY_CARRIAGE_INT, playerid, 50.0);
    subway_carriage_checkpoint[1] = CreateDynamicCP(1919.9463, -2435.3303, 13.6391, 1.0, 
        virtualworld, SUBWAY_CARRIAGE_INT, playerid, 50.0);
    subway_carriage_checkpoint[2] = CreateDynamicCP(1915.0021, -2435.3296, 13.6391, 1.0, 
        virtualworld, SUBWAY_CARRIAGE_INT, playerid, 50.0);
    subway_carriage_checkpoint[3] = CreateDynamicCP(1915.0792, -2431.2566, 13.6391, 1.0, 
        virtualworld, SUBWAY_CARRIAGE_INT, playerid, 50.0);
    subway_carriage_checkpoint[4] = CreateDynamicCP(1920.0820, -2431.2566, 13.6391, 1.0, 
        virtualworld, SUBWAY_CARRIAGE_INT, playerid, 50.0);
    subway_carriage_checkpoint[5] = CreateDynamicCP(1925.0803, -2431.2566, 13.6391, 1.0, 
        virtualworld, SUBWAY_CARRIAGE_INT, playerid, 50.0);
}

stock DestroyCarriageCP()
{
    for(new i; i < sizeof(subway_carriage_checkpoint); i++)
        DestroyDynamicCP(subway_carriage_checkpoint[i]),
        subway_carriage_checkpoint[i] = -1;
}

stock LoadSubwayResources()
{
    for(new i; i < SUBWAY_MAX_STATIONS; i++)
    {
        subway_enter_pickup[i] = CreateDynamicPickup(19607, 23, 
            subway_enter_pos[i][0], subway_enter_pos[i][1], subway_enter_pos[i][2]-2.7, 
            0, 0, _, 50.0);
        CreateDynamicMapIcon(subway_enter_pos[i][0], subway_enter_pos[i][1], subway_enter_pos[i][2], 
            56, 0, 0, 0, _, 50.0);
        new string[87];
        format(string, sizeof(string), "  \"%s\"\n\
            {FFFFFF} \"ALT\"  ", subway_station_name[i]);
        CreateDynamic3DTextLabel(string, COLOR_SERVER, 
            subway_enter_pos[i][0], subway_enter_pos[i][1], subway_enter_pos[i][2], 10.0, 
            _, _, 1, 0, 0, _, 50.0);
    }
    CreateDynamicPickup(19607, 23, 259.7442, 2521.4587, 17.8282-2.7, -1, SUBWAY_STATION_INT, _, 50.0);
    CreateDynamic3DTextLabel("  \n\
            {FFFFFF} \"ALT\"  ", COLOR_SERVER, 
            259.7188, 2521.4590, 17.8282, 5.0, 
            _, _, 1, -1, SUBWAY_STATION_INT, _, 50.0);
    CreateDynamicPickup(19607, 23, 256.3398, 2520.6384, 17.8282-2.7, -1, SUBWAY_STATION_INT, _, 50.0);
    CreateDynamic3DTextLabel("/ \n\
            {FFFFFF} \"ALT\"  ", COLOR_SERVER, 
            256.3398, 2520.6384, 17.8282, 5.0, 
            _, _, 1, -1, SUBWAY_STATION_INT, _, 50.0);
    CreateDynamicPickup(19607, 23, 265.5544, 2521.4165, 17.8345-2.7, -1, SUBWAY_STATION_INT, _, 50.0);
    CreateDynamic3DTextLabel(" \n\
            {FFFFFF} \"ALT\"  ", COLOR_SERVER,
            265.5544, 2521.4165, 17.8345, 5.0, 
            _, _, 1, -1, SUBWAY_STATION_INT, _, 50.0);
}

stock LoadSubwayMapping()
{
//=============================================================== [   ]
    new tmpobjid;
    tmpobjid = CreateDynamicObject(5772, 254.479415, 2507.947265, 22.820369, 0.000012, 0.000006, 88.929458, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, -1, "none", "none", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 11301, "carshow_sfse", "concpanel_la", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 3, 10765, "airportgnd_sfse", "white", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, -1, "none", "none", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 5, -1, "none", "none", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 6, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 7, -1, "none", "none", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 8, -1, "none", "none", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 9, -1, "none", "none", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 283.456604, 2516.703857, 18.991289, 0.000000, 0.000000, 179.700012, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 283.406127, 2507.073242, 18.991289, 0.000000, 0.000000, 179.700012, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 231.796310, 2516.703857, 18.991289, 0.000000, -0.000007, 179.699966, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 231.745834, 2507.073242, 18.991289, 0.000000, -0.000007, 179.699966, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(2431, 235.039978, 2509.867187, 21.481525, -15.399989, -0.000023, 179.899749, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, 10101, "2notherbuildsfe", "ferry_build14", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 5, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 240.389770, 2509.777832, 21.469921, -15.399989, -0.000023, 179.899749, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, 10101, "2notherbuildsfe", "ferry_build14", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 5, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 255.860015, 2509.757080, 21.481525, -15.399989, -0.000030, 179.899703, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, 10101, "2notherbuildsfe", "ferry_build14", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 5, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(1216, 283.122802, 2515.579589, 17.514524, -0.000007, 0.000000, -89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2431, 261.209808, 2509.667724, 21.469921, -15.399989, -0.000030, 179.899703, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, 10101, "2notherbuildsfe", "ferry_build14", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 5, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19381, 284.299133, 2509.578857, 18.991289, 0.000007, 0.000000, 89.699981, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 258.689147, 2521.906005, 17.897552, 0.000000, 0.000014, 90.100006, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(11714, 259.726165, 2521.832519, 18.058189, 0.000000, 0.000000, 90.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(11711, 259.712646, 2521.853759, 19.078174, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFCC);
    tmpobjid = CreateDynamicObject(19939, 233.218002, 2514.429687, 16.663728, -89.999992, 153.214782, 93.214607, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "CJ_Black_metal", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19939, 233.219223, 2515.427978, 16.663728, -89.999992, 153.062850, 93.062614, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "CJ_Black_metal", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2697, 233.185775, 2515.435791, 17.894197, -0.000083, 0.000020, -59.999855, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4004, "civic07_lan", "downtsign10_LA", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(19477, 241.636337, 2518.148925, 17.634511, 0.000000, -12.299990, 270.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "Los-Angeles", 130, "Engravers MT", 35, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19477, 271.146240, 2518.406005, 17.639877, 0.000000, -12.299990, 270.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "Los-Angeles", 130, "Engravers MT", 35, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(2697, 233.185897, 2514.436035, 17.894197, -0.000069, 0.000017, -59.999874, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4004, "civic07_lan", "downtsign11_LA", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(19939, 233.218490, 2513.428955, 16.663728, -89.999992, 153.214782, 93.214607, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "CJ_Black_metal", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2697, 233.185897, 2513.436035, 17.894197, -0.000069, 0.000017, -59.999874, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4004, "civic07_lan", "downtsign9_LA", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.244735, 2513.416015, 17.894197, 0.000000, -0.000003, 119.999946, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4004, "civic07_lan", "downtsign9_LA", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.244735, 2514.416015, 17.894197, 0.000000, -0.000003, 119.999946, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4004, "civic07_lan", "downtsign11_LA", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.244735, 2515.416015, 17.894197, 0.000000, -0.000003, 119.999946, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4004, "civic07_lan", "downtsign10_LA", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(19939, 233.118621, 2517.704101, 16.660133, -89.999992, 285.807434, 45.807292, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "CJ_Black_metal", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19939, 233.117401, 2516.706054, 16.660133, -89.999992, 285.769134, 45.768905, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "CJ_Black_metal", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2697, 233.150848, 2516.698242, 17.890602, -0.000088, 0.000014, 120.000053, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 2767, "cb_details", "fillets_cb", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.150604, 2517.697753, 17.890602, -0.000073, 0.000011, 120.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 2767, "cb_details", "wrapper_cb", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(19939, 233.118133, 2518.705078, 16.660133, -89.999992, 285.807434, 45.807292, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "CJ_Black_metal", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2697, 233.150604, 2518.697753, 17.890602, -0.000073, 0.000011, 120.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 2767, "cb_details", "cluckinbig_cb", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.091766, 2518.717773, 17.890602, 0.000003, 0.000001, -60.000091, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 2767, "cb_details", "cluckinbig_cb", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.091766, 2517.717773, 17.890602, 0.000003, 0.000001, -60.000091, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 2767, "cb_details", "wrapper_cb", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(2697, 233.091766, 2516.717773, 17.890602, 0.000003, 0.000001, -60.000091, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 2767, "cb_details", "fillets_cb", 0x9AAAAAAA);
    tmpobjid = CreateDynamicObject(19857, 253.908325, 2509.984375, 17.988660, 0.000019, 0.000020, -0.000144, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 255.147338, 2509.989257, 17.988660, 0.000019, 0.000020, -0.000144, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 256.656677, 2509.965820, 18.263656, -89.999992, 38.426734, 128.426635, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 256.656799, 2509.965820, 17.263658, -89.999992, 38.426734, 128.426635, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 253.914718, 2509.965820, 17.263658, 89.999992, 141.573272, -51.573356, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19381, 274.729187, 2509.626464, 18.991289, 0.000007, 0.000000, 89.699981, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 265.099456, 2509.679443, 18.991289, 0.000007, 0.000000, 89.699981, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 255.469558, 2509.730957, 18.991289, 0.000007, 0.000000, 89.699981, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 245.859680, 2509.781250, 18.991289, 0.000007, 0.000000, 89.699981, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19381, 236.269882, 2509.792236, 18.991289, 0.000007, 0.000000, 90.199974, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 13364, "cetown3cs_t", "ws_sandstone2", 0xFFFFFFEE);
    tmpobjid = CreateDynamicObject(19940, 253.914810, 2509.965820, 18.263656, 89.999992, 141.573272, -51.573356, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 255.675720, 2509.965820, 19.253665, 0.000000, -0.000019, 89.999771, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(1216, 283.122802, 2515.009033, 17.514524, -0.000007, 0.000000, -89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(1216, 283.122802, 2514.438476, 17.514524, -0.000007, 0.000000, -89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(1216, 283.122802, 2516.139404, 17.514524, -0.000007, 0.000000, -89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19857, 241.828292, 2509.984375, 17.988660, 0.000019, 0.000029, -0.000144, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 243.067306, 2509.989257, 17.988660, 0.000019, 0.000029, -0.000144, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 255.277465, 2508.527832, 17.988660, 0.000007, -0.000006, 89.999771, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 254.895767, 2509.965820, 19.253665, 0.000000, -0.000019, 89.999771, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 276.639801, 2509.656982, 21.481525, -15.399989, -0.000014, 179.899795, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, 10101, "2notherbuildsfe", "ferry_build14", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 5, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 281.989593, 2509.567626, 21.469921, -15.399989, -0.000014, 179.899795, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 1, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 2, 1736, "cj_ammo", "cj_pail", 0xFFFFFFEE);
    SetDynamicObjectMaterial(tmpobjid, 4, 10101, "2notherbuildsfe", "ferry_build14", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 5, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(4227, 254.147994, 2521.881591, 18.951953, 0.000000, -4.999998, 0.199999, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 5390, "glenpark7_lae", "ganggraf01_LA", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(4227, 241.247482, 2521.825683, 18.682888, 0.000000, 0.400000, 0.199999, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14801, "lee_bdupsmain", "Bdup_graf5", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 244.576644, 2509.965820, 18.263656, -89.999992, 21.163791, 111.163688, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 244.576766, 2509.965820, 17.263658, -89.999992, 21.163791, 111.163688, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(1359, 239.629180, 2518.035644, 17.508188, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(1359, 273.039245, 2518.035644, 17.508188, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19940, 241.834686, 2509.965820, 17.263658, 89.999992, 158.836212, -68.836296, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 241.834777, 2509.965820, 18.263656, 89.999992, 158.836212, -68.836296, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 243.595687, 2509.965820, 19.253665, 0.000007, -0.000019, 89.999748, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 243.197433, 2508.527832, 17.988660, 0.000014, -0.000006, 89.999748, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19526, 257.096008, 2522.304443, 17.140993, 37.700008, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 3, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 4, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 7, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19526, 256.336090, 2522.304443, 17.140993, 37.700008, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 3, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 4, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 7, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19526, 255.576080, 2522.304443, 17.140993, 37.700008, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 3, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 4, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 7, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19477, 256.385833, 2521.754638, 19.258197, -0.000007, 0.000000, -89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "  \n", 130, "Ariel", 25, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 255.947586, 2521.764648, 19.128189, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 256.727630, 2521.764648, 19.128189, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 256.727630, 2521.764648, 19.368196, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.947631, 2521.764648, 19.368196, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.907638, 2521.774658, 19.398197, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 256.767639, 2521.774658, 19.398197, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 256.767639, 2521.774658, 19.098190, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.907592, 2521.774658, 19.098190, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.907592, 2521.774658, 19.278194, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 256.767578, 2521.774658, 19.278194, 0.000007, 0.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 242.815734, 2509.965820, 19.253665, 0.000007, -0.000019, 89.999748, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 266.018218, 2509.984375, 17.988660, 0.000019, 0.000037, -0.000144, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 278.626953, 2510.099121, 15.094515, 0.000014, 0.000000, 88.999969, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1239, "icons6", "lyellow32", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 269.008605, 2510.266113, 15.094515, 0.000014, 0.000000, 88.999969, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1239, "icons6", "lyellow32", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 259.380310, 2510.334716, 15.094515, 0.000014, 0.000000, 90.099952, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1239, "icons6", "lyellow32", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 249.750320, 2510.316894, 15.094515, 0.000014, 0.000000, 90.099952, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1239, "icons6", "lyellow32", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 240.120315, 2510.299804, 15.094515, 0.000014, 0.000000, 90.099952, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1239, "icons6", "lyellow32", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 230.510269, 2510.281494, 15.094515, 0.000014, 0.000000, 90.099952, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1239, "icons6", "lyellow32", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 267.257232, 2509.989257, 17.988660, 0.000019, 0.000037, -0.000144, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 268.766571, 2509.965820, 18.263656, -89.999992, 10.931138, 100.931015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 268.766693, 2509.965820, 17.263658, -89.999992, 10.931138, 100.931015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 266.024597, 2509.965820, 17.263658, 89.999992, 169.068878, -79.068939, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(2671, 244.634063, 2517.192382, 16.838186, 0.000000, 0.000000, 45.099998, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFCC);
    tmpobjid = CreateDynamicObject(2674, 270.631378, 2517.601074, 16.834526, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19940, 266.024719, 2509.965820, 18.263656, 89.999992, 169.068878, -79.068939, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 267.785614, 2509.965820, 19.253665, 0.000014, -0.000019, 89.999725, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(1776, 238.683639, 2521.320068, 17.934524, 0.000000, 0.000007, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(955, 239.954696, 2521.393554, 17.228189, 0.000000, 0.000007, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(1776, 272.553741, 2521.320068, 17.934524, 0.000000, 0.000014, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(955, 273.824798, 2521.393554, 17.228189, 0.000000, 0.000014, 0.000000, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, -1, "none", "none", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19476, 265.277435, 2521.774658, 19.058187, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.827392, 2521.774658, 19.058187, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.827392, 2521.774658, 17.738189, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.277313, 2521.774658, 17.738189, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 264.887268, 2521.774658, 18.648216, 89.999992, 360.000000, -90.000022, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 264.887268, 2521.774658, 18.298210, 89.999992, 360.000000, -90.000022, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.217468, 2521.774658, 18.298210, 89.999992, 360.000000, -90.000022, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.217468, 2521.774658, 18.558216, 89.999992, 360.000000, -90.000022, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.047363, 2521.764648, 19.628189, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.997375, 2521.764648, 19.628189, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.047363, 2521.764648, 19.418184, 0.000037, 0.000000, 89.999885, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.997375, 2521.764648, 19.418184, 0.000037, 0.000000, 89.999885, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.007354, 2521.774658, 19.658195, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.037445, 2521.774658, 19.658195, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.037445, 2521.774658, 19.398189, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.007354, 2521.774658, 19.398189, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 265.007354, 2521.774658, 19.458190, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.037506, 2521.774658, 19.458190, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19477, 265.605712, 2521.754638, 19.518203, -0.000007, 0.000000, -89.999977, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, " \n", 130, "Ariel", 29, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 255.857604, 2521.754882, 18.138185, 0.000007, 0.000000, 269.999969, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "m-ticket", 120, "Engravers MT", 41, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 256.637725, 2521.754882, 18.138185, 0.000007, 0.000000, 269.999969, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "m-ticket", 120, "Engravers MT", 41, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 257.367767, 2521.754882, 18.138185, 0.000007, 0.000000, 269.999969, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "m-ticket", 120, "Engravers MT", 41, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 266.367736, 2521.754882, 18.488185, 0.000007, 0.000000, 269.999969, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "Jefferson", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 266.557708, 2521.754882, 18.428184, 0.000000, 0.000000, -90.000007, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "east side", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 266.557708, 2521.754882, 18.238180, -0.000007, 0.000000, -89.999984, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "l.s.forum", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 266.437561, 2521.754882, 18.088176, -0.000014, 0.000000, -89.999961, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "willowfield", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 266.177612, 2521.754882, 18.108177, -0.000023, 0.000000, -89.999938, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "unity", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19476, 265.597656, 2521.754882, 18.028175, -0.000030, 0.000000, -89.999916, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "airport", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.327514, 2521.754882, 18.288181, -0.000054, 0.000000, -89.999847, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "verona bch.", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.037445, 2521.754882, 18.288181, -0.000060, 0.000000, -89.999824, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "santa maria bch", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.067474, 2521.754882, 18.418184, -0.000069, 0.000000, -89.999801, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "rodeo", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.417572, 2521.754882, 18.458185, -0.000075, 0.000000, -89.999778, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "market sqr.", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.577514, 2521.754882, 18.608188, -0.000092, 0.000000, -89.999732, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "commercial", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.757598, 2521.754882, 18.558187, -0.000098, 0.000000, -89.999710, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "glen park", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 265.907684, 2521.754882, 18.278181, -0.000115, 0.000000, -89.999664, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    SetDynamicObjectMaterialText(tmpobjid, 0, "Idelwood", 120, "Engravers MT", 15, 0, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19857, 267.387359, 2508.527832, 17.988660, 0.000022, -0.000006, 89.999725, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 267.005676, 2509.965820, 19.253665, 0.000014, -0.000019, 89.999725, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 267.817352, 2509.800292, 19.788192, 0.000036, 0.000000, -90.000083, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.867340, 2509.800292, 19.788192, 0.000036, 0.000000, -90.000083, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 267.817352, 2509.800292, 19.578187, 0.000044, 0.000000, -90.000106, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.867340, 2509.800292, 19.578187, 0.000044, 0.000000, -90.000106, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 267.857360, 2509.790283, 19.818199, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.827270, 2509.790283, 19.818199, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.827270, 2509.790283, 19.558193, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 267.857360, 2509.790283, 19.558193, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 267.857360, 2509.790283, 19.618194, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 266.827209, 2509.790283, 19.618194, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19477, 267.289001, 2509.810302, 19.678207, -0.000014, 0.000000, 89.999984, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, " #1", 130, "Ariel", 50, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 255.707336, 2509.840332, 19.788192, 0.000028, 0.000000, -90.000061, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 254.757324, 2509.840332, 19.788192, 0.000028, 0.000000, -90.000061, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.707336, 2509.840332, 19.578187, 0.000036, 0.000000, -90.000083, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 254.757324, 2509.840332, 19.578187, 0.000036, 0.000000, -90.000083, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.747344, 2509.830322, 19.818199, 0.000012, 0.000000, -90.000015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 254.717254, 2509.830322, 19.818199, 0.000012, 0.000000, -90.000015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 254.717254, 2509.830322, 19.558193, 0.000012, 0.000000, -90.000015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.747344, 2509.830322, 19.558193, 0.000012, 0.000000, -90.000015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 255.747344, 2509.830322, 19.618194, 0.000012, 0.000000, -90.000015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 254.717193, 2509.830322, 19.618194, 0.000012, 0.000000, -90.000015, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19477, 255.178985, 2509.850341, 19.678207, -0.000006, 0.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, " #2", 130, "Ariel", 50, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 243.627380, 2509.910400, 19.788192, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 242.677368, 2509.910400, 19.788192, 0.000020, 0.000000, -90.000038, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 243.627380, 2509.910400, 19.578187, 0.000029, 0.000000, -90.000061, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 242.677368, 2509.910400, 19.578187, 0.000029, 0.000000, -90.000061, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 243.667388, 2509.900390, 19.818199, 0.000006, 0.000000, -89.999992, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 242.637298, 2509.900390, 19.818199, 0.000006, 0.000000, -89.999992, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 242.637298, 2509.900390, 19.558193, 0.000006, 0.000000, -89.999992, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 243.667388, 2509.900390, 19.558193, 0.000006, 0.000000, -89.999992, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 243.667388, 2509.900390, 19.618194, 0.000006, 0.000000, -89.999992, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 242.637237, 2509.900390, 19.618194, 0.000006, 0.000000, -89.999992, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19477, 243.099029, 2509.920410, 19.678207, 0.000000, 0.000000, 89.999938, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, " #3", 130, "Ariel", 50, 1, 0xFF000000, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19476, 258.737426, 2521.814697, 20.108205, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 259.757354, 2521.814697, 20.108205, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 260.717254, 2521.814697, 20.108209, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 260.717254, 2521.814697, 19.888210, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 258.737243, 2521.814697, 19.888210, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 259.747192, 2521.814697, 19.888210, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 259.747192, 2521.814697, 19.698207, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 260.717254, 2521.814697, 19.698207, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 258.737213, 2521.814697, 19.698207, 0.000014, 0.000000, 89.999954, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 258.777404, 2521.794677, 20.078187, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 258.777404, 2521.794677, 19.728187, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 260.677368, 2521.794677, 19.728187, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 259.717407, 2521.794677, 19.728187, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 259.717407, 2521.794677, 20.078195, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 260.677429, 2521.794677, 20.078195, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 260.677429, 2521.794677, 19.958192, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 258.777313, 2521.794677, 19.958192, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(19476, 259.767486, 2521.794677, 19.958192, 0.000029, 0.000000, 89.999908, -1, -1, -1, 150.00, 150.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10765, "airportgnd_sfse", "white", 0x00000000);
    tmpobjid = CreateDynamicObject(4227, 281.484802, 2521.594482, 18.654527, 0.000000, 0.000000, -0.999997, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19171, 265.551422, 2521.782226, 18.394519, 89.999992, 89.999992, -89.999992, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(18608, 268.661651, 2515.835937, 23.984533, 0.000000, 0.000000, 90.000000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(18608, 246.041534, 2515.835937, 23.984533, 0.000000, 0.000000, 90.000000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(11745, 243.491638, 2517.939208, 17.018186, 0.000000, 0.000000, 20.100002, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(2673, 240.883056, 2517.081298, 16.928188, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(2673, 273.802947, 2517.671875, 16.928188, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(2059, 255.886047, 2521.448730, 16.834526, 0.000000, 0.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(2059, 256.773803, 2521.208496, 16.834526, 0.000000, 0.000000, -95.500000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.945129, 2521.760986, 18.574535, 630.000000, 540.000000, 0.000000, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 266.135101, 2521.760986, 18.514532, -89.999992, 630.000000, 89.999992, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 266.135101, 2521.760986, 18.324529, -89.999992, 630.000000, 89.999977, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 266.024963, 2521.760986, 18.174526, -89.999992, 630.000000, 89.999969, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.704956, 2521.760986, 18.194526, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.595001, 2521.760986, 18.004522, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.494964, 2521.760986, 18.294527, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.314880, 2521.760986, 18.264528, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.024810, 2521.760986, 18.264528, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.054840, 2521.760986, 18.394531, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.404937, 2521.760986, 18.434532, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.564880, 2521.760986, 18.584535, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.744964, 2521.760986, 18.534534, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
    tmpobjid = CreateDynamicObject(19181, 265.895050, 2521.760986, 18.254528, -89.999992, 630.000000, 89.999961, -1, -1, -1, 150.00, 150.00); 
//=============================================================== [   ]
    tmpobjid = CreateDynamicObject(7313, 1926.609497, -2433.529785, 15.009119, 0.000000, 0.000000, 270.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "Los-Angeles Metropolitan", 110, "Quartz MS", 36, 1, 0xFFFFFFFF, 0x00000001, 1);
    tmpobjid = CreateDynamicObject(7313, 1913.540039, -2433.529785, 15.009119, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00);
    SetDynamicObjectMaterialText(tmpobjid, 0, "Los-Angeles Metropolitan", 110, "Quartz MS", 32, 1, 0xFFFFFFFF, 0x00000001, 1);
    tmpobjid = CreateDynamicObject(8661, 1918.750366, -2435.684814, 12.639118, 0.000000, 0.000000, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3980, "cityhall_lan", "man_cellarfloor128", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(3657, 1922.490722, -2435.159912, 13.219122, 5.000020, -0.000018, -179.999801, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19383, 1925.025634, -2435.604980, 14.139118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19399, 1922.525512, -2435.609863, 14.139118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19383, 1920.030639, -2435.604980, 14.139118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19399, 1917.535034, -2435.609863, 14.139118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19857, 1923.620483, -2435.723388, 13.639124, 0.000000, 0.000014, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1924.859619, -2435.718505, 13.639124, 0.000000, 0.000014, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19071, 1900.767456, -2436.311279, -3.078903, 180.000000, 90.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 9514, "711_sfw", "supasave_wintemp", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 9514, "711_sfw", "supasave_wintemp", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 4593, "buildblk55", "snpdsqdoor", 0x00000000);
    tmpobjid = CreateDynamicObject(3657, 1917.510009, -2435.159912, 13.219122, 5.000020, -0.000018, -179.999801, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19480, 1919.940551, -2436.494384, 12.649115, 180.000000, 90.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3694, "ryderholes", "ryd_holes", 0x80000000);
    tmpobjid = CreateDynamicObject(19383, 1926.662597, -2433.273681, 14.139116, 0.000007, -0.000014, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19857, 1926.781005, -2434.678710, 13.639125, 0.000014, 0.000022, 89.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1926.776123, -2433.439697, 13.639125, 0.000014, 0.000022, 89.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1926.799560, -2432.550537, 13.914123, -89.999992, 244.471206, 64.471183, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1926.799560, -2432.550537, 12.914123, -89.999992, 244.471206, 64.471183, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1926.799560, -2434.031982, 12.914123, 89.999992, -64.471237, -115.528800, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1926.799560, -2434.031982, 13.914123, 89.999992, -64.471237, -115.528800, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19481, 1910.520507, -2435.787841, 12.399115, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18065, "ab_sfammumain", "shelf_glas", 0xFF202020);
    tmpobjid = CreateDynamicObject(19940, 1925.748779, -2435.741943, 13.914122, 630.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1925.748779, -2435.741943, 12.914122, 630.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1924.267333, -2435.741943, 12.914122, 810.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1924.267333, -2435.741943, 13.914122, 810.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1924.958007, -2435.741943, 14.864130, 1080.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1925.720458, -2437.189941, 13.639124, 0.000000, 0.000014, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1924.299072, -2437.189941, 13.639124, 0.000000, 0.000014, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1924.989746, -2437.179931, 13.639124, 0.000000, 0.000014, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(1897, 1922.448730, -2435.744140, 13.519115, 89.999992, 179.999984, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1922.448730, -2435.744140, 15.069113, -89.999992, 45.098960, 135.098999, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1923.289550, -2435.746093, 14.609104, -0.000014, 179.999984, -89.999961, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1921.778076, -2435.746093, 14.609104, 0.000014, 0.000000, 89.999931, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1922.448730, -2435.744140, 14.669116, -89.999992, 45.098960, 135.098999, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(19940, 1922.529663, -2435.741943, 13.594120, 0.000000, 179.999984, -90.000007, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1921.658813, -2435.741943, 14.454119, 89.999992, 0.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1923.408691, -2435.741943, 14.454119, -89.999992, 179.999984, -90.000007, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1922.529663, -2435.741943, 14.994129, 0.000000, 0.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(1897, 1917.448486, -2435.744140, 13.519115, 89.999992, 180.000000, -89.999961, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1917.448486, -2435.744140, 15.069113, -89.999992, 25.596660, 115.596694, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1918.289306, -2435.746093, 14.609104, -0.000022, 179.999984, -89.999938, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1916.777832, -2435.746093, 14.609104, 0.000022, 0.000000, 89.999908, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1917.448486, -2435.744140, 14.669116, -89.999992, 25.596660, 115.596694, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(19940, 1917.529418, -2435.741943, 13.594120, -0.000007, 179.999984, -89.999984, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1916.658569, -2435.741943, 14.454119, 89.999992, 89.934043, 0.065913, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1918.408447, -2435.741943, 14.454119, -89.999992, 90.197845, -179.802124, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1917.529418, -2435.741943, 14.994129, 0.000007, 0.000000, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1918.632324, -2435.723388, 13.639124, 0.000000, 0.000022, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1919.871459, -2435.718505, 13.639124, 0.000000, 0.000022, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1920.760620, -2435.741943, 13.914122, -89.999992, 179.999984, -90.000007, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1920.760620, -2435.741943, 12.914122, -89.999992, 179.999984, -90.000007, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1919.279174, -2435.741943, 12.914122, 89.999992, 0.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1919.279174, -2435.741943, 13.914122, 89.999992, 0.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1919.969848, -2435.741943, 14.864130, 0.000000, 0.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1920.732299, -2437.189941, 13.639124, 0.000007, 0.000014, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1919.310913, -2437.189941, 13.639124, 0.000007, 0.000014, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1920.001586, -2437.179931, 13.639124, 0.000007, 0.000014, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19383, 1915.038452, -2435.604980, 14.139118, 0.000007, 0.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19857, 1913.640136, -2435.723388, 13.639124, 0.000000, 0.000029, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1914.879272, -2435.718505, 13.639124, 0.000000, 0.000029, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1915.768432, -2435.741943, 13.914122, -89.999992, 90.197845, -179.802124, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1915.768432, -2435.741943, 12.914122, -89.999992, 90.197845, -179.802124, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1914.286987, -2435.741943, 12.914122, 89.999992, 89.934043, 0.065913, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1914.286987, -2435.741943, 13.914122, 89.999992, 89.934043, 0.065913, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1914.977661, -2435.741943, 14.864130, 0.000007, 0.000000, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1915.740112, -2437.189941, 13.639124, 0.000014, 0.000014, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1914.318725, -2437.189941, 13.639124, 0.000014, 0.000014, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1915.009399, -2437.179931, 13.639124, 0.000014, 0.000014, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1926.799560, -2433.341308, 14.864130, 0.000000, -0.000014, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1928.247558, -2432.578857, 13.639125, 0.000007, 0.000000, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1928.247558, -2434.000244, 13.639125, 0.000007, 0.000000, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1928.237548, -2433.309570, 13.639125, 0.000007, 0.000000, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 1921.816284, -2434.609863, 16.411624, 360.000000, 220.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10140, "frieghter2sfe", "sf_ship_interior", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1921.816284, -2433.309570, 15.891613, 0.000000, 270.000000, -90.000007, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10140, "frieghter2sfe", "sf_ship_ceiling", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19445, 1912.186279, -2434.609863, 16.411624, 360.000000, 220.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10140, "frieghter2sfe", "sf_ship_interior", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1912.186279, -2433.309570, 15.891613, 0.000000, 270.000000, -90.000007, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10140, "frieghter2sfe", "sf_ship_ceiling", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(3657, 1917.578735, -2431.426269, 13.219122, 5.000020, -0.000011, 0.000182, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19383, 1915.043823, -2430.981201, 14.139118, -0.000007, 0.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19399, 1917.543945, -2430.976318, 14.139118, -0.000007, 0.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19383, 1920.038818, -2430.981201, 14.139118, -0.000007, 0.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19399, 1922.534423, -2430.976318, 14.139118, -0.000007, 0.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19857, 1916.448974, -2430.862792, 13.639124, 0.000000, 0.000007, 179.999847, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1915.209838, -2430.867675, 13.639124, 0.000000, 0.000007, 179.999847, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(3657, 1922.559448, -2431.426269, 13.219122, 5.000020, -0.000011, 0.000182, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19480, 1920.128906, -2430.091796, 12.649115, 0.000014, 270.000000, 89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3694, "ryderholes", "ryd_holes", 0x80000000);
    tmpobjid = CreateDynamicObject(19481, 1929.548950, -2430.798339, 12.399115, -0.000007, 0.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18065, "ab_sfammumain", "shelf_glas", 0xFF202020);
    tmpobjid = CreateDynamicObject(19940, 1914.320678, -2430.844238, 13.914122, -89.999992, 180.000000, 89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1914.320678, -2430.844238, 12.914122, -89.999992, 180.000000, 89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1915.802124, -2430.844238, 12.914122, 89.999992, 0.000015, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1915.802124, -2430.844238, 13.914122, 89.999992, 0.000015, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1915.111450, -2430.844238, 14.864130, -0.000014, 0.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1914.348999, -2429.396240, 13.639124, -0.000007, 0.000014, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1915.770385, -2429.396240, 13.639124, -0.000007, 0.000014, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1915.079711, -2429.406250, 13.639124, -0.000007, 0.000014, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(1897, 1917.620727, -2430.842041, 13.519115, 89.999992, 314.934020, -44.934055, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1917.620727, -2430.842041, 15.069113, -89.999992, 157.642608, 67.642639, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1916.779907, -2430.840087, 14.609104, -0.000007, 179.999984, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1918.291381, -2430.840087, 14.609104, 0.000007, 0.000000, -90.000015, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1917.620727, -2430.842041, 14.669116, -89.999992, 157.642608, 67.642639, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(19940, 1917.539794, -2430.844238, 13.594120, 0.000007, 179.999984, 89.999908, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1918.410644, -2430.844238, 14.454119, 89.999992, 25.483594, -115.483551, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1916.660766, -2430.844238, 14.454119, -89.999992, 154.606643, 64.606605, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1917.539794, -2430.844238, 14.994129, -0.000007, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(1897, 1922.620971, -2430.842041, 13.519115, 89.999992, 314.901062, -44.901054, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1922.620971, -2430.842041, 15.069113, -89.999992, 147.615615, 57.615661, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1921.780151, -2430.840087, 14.609104, -0.000014, 179.999984, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1923.291625, -2430.840087, 14.609104, 0.000014, 0.000000, -90.000038, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(1897, 1922.620971, -2430.842041, 14.669116, -89.999992, 147.615615, 57.615661, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10023, "bigwhitesfe", "bigwhite_3", 0xFFAAAAAA);
    tmpobjid = CreateDynamicObject(19940, 1922.540039, -2430.844238, 13.594120, 0.000000, 179.999984, 89.999931, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1923.410888, -2430.844238, 14.454119, 89.999992, 25.483543, -115.483589, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1921.661010, -2430.844238, 14.454119, -89.999992, 154.606857, 64.606880, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1922.540039, -2430.844238, 14.994129, 0.000000, 0.000000, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1921.437133, -2430.862792, 13.639124, 0.000000, 0.000014, 179.999847, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1920.197998, -2430.867675, 13.639124, 0.000000, 0.000014, 179.999847, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1919.308837, -2430.844238, 13.914122, -89.999992, 154.606643, 64.606605, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1919.308837, -2430.844238, 12.914122, -89.999992, 154.606643, 64.606605, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1920.790283, -2430.844238, 12.914122, 89.999992, 25.483594, -115.483551, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1920.790283, -2430.844238, 13.914122, 89.999992, 25.483594, -115.483551, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1920.099609, -2430.844238, 14.864130, -0.000007, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1919.337158, -2429.396240, 13.639124, 0.000000, 0.000014, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1920.758544, -2429.396240, 13.639124, 0.000000, 0.000014, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1920.067871, -2429.406250, 13.639124, 0.000000, 0.000014, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19383, 1925.031005, -2430.981201, 14.139118, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19857, 1926.429321, -2430.862792, 13.639124, 0.000000, 0.000022, 179.999847, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1925.190185, -2430.867675, 13.639124, 0.000000, 0.000022, 179.999847, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1924.301025, -2430.844238, 13.914122, -89.999992, 154.606857, 64.606880, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1924.301025, -2430.844238, 12.914122, -89.999992, 154.606857, 64.606880, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1925.782470, -2430.844238, 12.914122, 89.999992, 25.483543, -115.483589, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1925.782470, -2430.844238, 13.914122, 89.999992, 25.483543, -115.483589, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1925.091796, -2430.844238, 14.864130, 0.000000, 0.000000, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1924.329345, -2429.396240, 13.639124, 0.000007, 0.000014, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1925.750732, -2429.396240, 13.639124, 0.000007, 0.000014, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1925.060058, -2429.406250, 13.639124, 0.000007, 0.000014, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19445, 1918.253173, -2431.976318, 16.411624, -0.000014, 220.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10140, "frieghter2sfe", "sf_ship_interior", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1926.662597, -2430.063720, 14.139116, 0.000007, -0.000014, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1927.883178, -2431.976318, 16.411624, -0.000014, 220.000000, -89.999946, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10140, "frieghter2sfe", "sf_ship_interior", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1926.662597, -2436.483642, 14.139116, 0.000007, -0.000014, 179.999862, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19383, 1913.436035, -2433.303710, 14.139116, 0.000007, -0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19857, 1913.317626, -2431.898681, 13.639125, 0.000007, 0.000022, -90.000022, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1913.322509, -2433.137695, 13.639125, 0.000007, 0.000022, -90.000022, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 18646, "matcolours", "grey-60-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1913.299072, -2434.026855, 13.914123, -89.999992, 122.418388, 122.418350, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1913.299072, -2434.026855, 12.914123, -89.999992, 122.418388, 122.418350, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1913.299072, -2432.545410, 12.914123, 89.999992, 57.581573, -57.581653, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1913.299072, -2432.545410, 13.914123, 89.999992, 57.581573, -57.581653, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 1913.299072, -2433.236083, 14.864130, 0.000000, -0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1911.851074, -2433.998535, 13.639125, 0.000007, 0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1911.851074, -2432.577148, 13.639125, 0.000007, 0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3440, "airportpillar", "metalic_64", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19857, 1911.861083, -2433.267822, 13.639125, 0.000007, 0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-80-percent", 0xFFFFFFFF);
    SetDynamicObjectMaterial(tmpobjid, 1, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(19353, 1913.436035, -2436.513671, 14.139116, 0.000007, -0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1913.436035, -2430.093750, 14.139116, 0.000007, -0.000007, -0.000151, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12848, "cunte_town1", "rufwallb256hi", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19071, 1900.767456, -2430.262207, -3.078903, 360.000000, 90.000000, 270.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 9514, "711_sfw", "supasave_wintemp", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 9514, "711_sfw", "supasave_wintemp", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 4593, "buildblk55", "snpdsqdoor", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 1915.018188, -2433.749023, 15.940023, 74.999992, 0.000088, -0.000084, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 14534, "ab_wooziea", "light_full", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 1919.018188, -2433.749023, 15.940023, 74.999992, 0.000088, -0.000084, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 14534, "ab_wooziea", "light_full", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 1923.018188, -2433.749023, 15.940023, 74.999992, 0.000088, -0.000084, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 14534, "ab_wooziea", "light_full", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1924.419189, -2435.990234, 14.609132, -89.999992, 89.999992, 89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1924.421142, -2435.990234, 13.599123, -89.999992, 89.999992, 89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(3657, 1927.440795, -2435.159912, 13.219122, 5.000020, -0.000018, -179.999801, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(3657, 1912.551391, -2435.159912, 13.219122, 5.000020, -0.000018, -179.999801, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(3657, 1912.588745, -2431.426269, 13.219122, 5.000020, -0.000011, 0.000182, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(3657, 1927.520751, -2431.426269, 13.219122, 5.000020, -0.000011, 0.000182, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 1, 14652, "ab_trukstpa", "CJ_CORD", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 19962, "samproadsigns", "materialtext1", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1923.768554, -2435.990234, 14.837139, 0.000007, 90.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1920.998413, -2435.990234, 14.609132, -89.999992, 89.999992, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1921.000366, -2435.990234, 13.599123, -89.999992, 89.999992, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1922.467773, -2435.990234, 14.839138, 0.000007, 90.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1919.425292, -2435.990234, 14.609132, -89.999992, 89.999992, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1919.427246, -2435.990234, 13.599123, -89.999992, 89.999992, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1918.774658, -2435.990234, 14.837139, 0.000014, 90.000000, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1916.004516, -2435.990234, 14.609132, -89.999992, 90.000000, 89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1916.006469, -2435.990234, 13.599123, -89.999992, 90.000000, 89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1917.473876, -2435.990234, 14.839138, 0.000014, 90.000000, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1925.990112, -2435.990234, 14.609132, -89.999992, 89.999992, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1925.992065, -2435.990234, 13.599123, -89.999992, 89.999992, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1927.448364, -2435.990234, 14.837139, 0.000007, 90.000000, 89.999977, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1914.442993, -2435.990234, 14.609132, -89.999992, 90.000015, 89.999961, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1914.444946, -2435.990234, 13.599123, -89.999992, 90.000015, 89.999961, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1913.792968, -2435.990234, 14.839138, 0.000014, 90.000000, 89.999954, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1915.650878, -2430.616210, 14.609132, -89.999992, 179.950531, -0.049417, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1915.648925, -2430.616210, 13.599123, -89.999992, 179.950531, -0.049417, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1916.301513, -2430.616210, 14.837139, 0.000000, 90.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1919.071655, -2430.616210, 14.609132, -89.999992, -44.801963, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1919.069702, -2430.616210, 13.599123, -89.999992, -44.801963, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1917.602294, -2430.616210, 14.839138, 0.000000, 90.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1920.644775, -2430.616210, 14.609132, -89.999992, -44.801963, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1920.642822, -2430.616210, 13.599123, -89.999992, -44.801963, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1921.295410, -2430.616210, 14.837139, 0.000007, 90.000000, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1924.065551, -2430.616210, 14.609132, -89.999992, -44.801948, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1924.063598, -2430.616210, 13.599123, -89.999992, -44.801948, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1922.596191, -2430.616210, 14.839138, 0.000007, 90.000000, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1914.079956, -2430.616210, 14.609132, -89.999992, -44.801963, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1914.078002, -2430.616210, 13.599123, -89.999992, -44.801963, 135.198074, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1912.621704, -2430.616210, 14.837139, 0.000000, 90.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1925.627075, -2430.616210, 14.609132, -89.999992, -44.900993, 135.098999, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1925.625122, -2430.616210, 13.599123, -89.999992, -44.900993, 135.098999, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2372, 1926.277099, -2430.616210, 14.839138, 0.000007, 90.000000, -89.999992, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 1560, "7_11_door", "CJ_CHROME2", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 1915.018188, -2431.736816, 15.940023, 74.999992, 0.000117, -0.000113, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 14534, "ab_wooziea", "light_full", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 1919.018188, -2431.736816, 15.940023, 74.999992, 0.000117, -0.000113, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 14534, "ab_wooziea", "light_full", 0x00000000);
    tmpobjid = CreateDynamicObject(2431, 1923.018188, -2431.736816, 15.940023, 74.999992, 0.000117, -0.000113, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 1, 14534, "ab_wooziea", "light_full", 0x00000000);
    SetDynamicObjectMaterial(tmpobjid, 2, 14534, "ab_wooziea", "light_full", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1925.078125, -2435.249511, 15.516716, -40.000000, 0.000009, 0.000006, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 6282, "beafron2_law2", "hollysign02_LAw", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1922.578125, -2435.249511, 15.516716, -40.000000, 0.000009, 0.000006, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 6282, "beafron2_law2", "giftsign01_law", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1920.078125, -2435.249511, 15.516716, -40.000000, 0.000009, 0.000006, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 6282, "beafron2_law2", "downtsign3_LA", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1917.578125, -2435.249511, 15.516716, -40.000000, 0.000009, 0.000006, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17508, "barrio1_lae2", "gangsign4_LAe", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1915.078125, -2435.249511, 15.516716, -40.000000, 0.000009, 0.000006, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17508, "barrio1_lae2", "gangsign3_LAe", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1915.078125, -2431.326904, 15.516716, -40.000000, 0.000009, 179.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 5444, "chicano10_lae", "comptsign4_LAe", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1917.578125, -2431.326904, 15.516716, -40.000000, 0.000009, 179.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 12946, "ce_bankalley1", "sw_furnisign", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1920.078125, -2431.326904, 15.516716, -40.000000, 0.000009, 179.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 4001, "civic03_lan", "downtsign2_LA", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1922.578125, -2431.326904, 15.516716, -40.000000, 0.000009, 179.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3988, "civic06_lan", "downtsign1_LA", 0x00000000);
    tmpobjid = CreateDynamicObject(2659, 1925.078125, -2431.326904, 15.516716, -40.000000, 0.000009, 179.999923, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3988, "civic06_lan", "downtsign4_LA", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.566528, -2434.743896, 14.199117, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 15040, "cuntcuts", "csnewspaper", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.576538, -2431.862548, 14.199117, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 15040, "cuntcuts", "csnewspaper02", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.533813, -2431.832519, 14.199117, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 15040, "cuntcuts", "csnewspaper", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.513793, -2434.713867, 14.199117, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 15040, "cuntcuts", "csnewspaper02", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2434.783935, 14.229118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2434.703857, 14.229118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2434.703857, 14.169116, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2434.783935, 14.169116, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2431.893554, 14.169116, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2431.823486, 14.169116, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2431.823486, 14.229118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1913.556518, -2431.893554, 14.229118, 0.000000, 0.000000, 90.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.543823, -2431.792480, 14.229118, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.543823, -2431.872558, 14.229118, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.543823, -2431.872558, 14.169116, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.543823, -2431.792480, 14.169116, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.523803, -2434.673828, 14.229118, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.523803, -2434.753906, 14.229118, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.523803, -2434.753906, 14.169116, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2668, 1926.523803, -2434.673828, 14.169116, 0.000000, 0.000000, -89.999969, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 3899, "hospital2", "black", 0x00000000);
    tmpobjid = CreateDynamicObject(2986, 1920.486694, -2433.303222, 15.769117, 0.000000, 0.000000, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    tmpobjid = CreateDynamicObject(2986, 1924.486694, -2433.303222, 15.769117, 0.000000, 0.000000, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    tmpobjid = CreateDynamicObject(2986, 1916.486694, -2433.303222, 15.769117, 0.000000, 0.000000, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    tmpobjid = CreateDynamicObject(19624, 1921.969970, -2434.721435, 13.039118, 0.000000, 0.000000, 0.000000, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00); 
    tmpobjid = CreateDynamicObject(19624, 1918.677978, -2431.481933, 13.039118, 0.000000, 0.000000, 55.099998, -1, SUBWAY_CARRIAGE_INT, -1, 100.00, 100.00);
//=============================================================== [   ]
    tmpobjid = CreateDynamicObject(11714, 2236.106689, -1150.287353, 26.062484, 0.000014, -0.000014, 85.699813, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(11714, 2579.765625, -1285.213745, 46.306549, 0.000022, -0.000021, -179.500198, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 2236.254882, -1148.328979, 28.099885, -0.000014, -0.000024, 176.099822, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 2236.211181, -1148.386108, 28.099885, 0.000014, 0.000024, -3.900093, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2236.192871, -1149.170776, 27.823167, -0.000014, 270.000000, 176.099929, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2236.110595, -1150.378295, 26.142480, 0.000020, -0.000014, 86.099792, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 2237.645996, -1150.146240, 26.142480, -0.000014, -0.000024, 176.099822, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2237.665283, -1150.162475, 25.992473, -0.000014, -0.000024, 176.099822, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2234.628662, -1149.935424, 26.142480, 0.000009, -359.999938, 176.099716, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2234.600341, -1149.953491, 25.992473, 0.000009, -359.999938, 176.099716, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(2643, 2577.802001, -1285.229858, 48.343948, -0.000021, -0.000033, -89.100143, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 2577.862548, -1285.268676, 48.343948, 0.000021, 0.000033, 90.899856, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19940, 2236.108886, -1150.293945, 27.572475, -0.000007, 270.000000, -93.900032, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2237.612548, -1150.861083, 25.992473, -0.000014, -0.000020, 176.099868, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2234.554443, -1150.652709, 25.992473, 0.000009, -359.999938, 176.099746, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2236.083740, -1150.771972, 27.823167, -0.000014, 270.000000, 176.099929, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2237.615234, -1150.971313, 23.320636, -0.000014, 179.999984, 176.099929, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2234.509765, -1150.759643, 23.320636, -0.000014, 179.999984, 176.099975, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2237.445068, -1153.464843, 23.320636, -0.000014, 179.999984, 176.099929, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2234.339843, -1153.253051, 23.320636, -0.000014, 179.999984, 176.099975, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2237.378906, -1154.213867, 23.320636, -40.000003, -0.000027, 176.099868, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2234.334472, -1154.006469, 23.320636, -40.000003, -0.000027, 176.099868, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2235.783935, -1155.195190, 24.751920, -40.000003, 270.000000, 176.099899, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 2236.087402, -1150.258544, 27.538394, 0.000020, -0.000014, 86.099792, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "JEFFERSON STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 2235.257324, -1148.177246, 27.948404, 0.000020, -0.000014, 91.099792, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19426, 2578.645996, -1285.221313, 48.067230, -0.000021, 270.000000, -89.100036, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2579.856201, -1285.202270, 46.386543, 0.000029, -0.000021, -179.100219, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 2579.496337, -1283.691650, 46.386543, -0.000021, -0.000033, -89.100143, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2579.510986, -1283.671020, 46.236534, -0.000021, -0.000033, -89.100143, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2579.538818, -1286.716064, 46.386543, 0.000002, -359.999938, -89.100250, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2579.559326, -1286.742797, 46.236534, 0.000002, -359.999938, -89.100250, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 2579.772460, -1285.210937, 47.816535, -0.000015, 270.000000, 0.899958, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2580.211425, -1283.665161, 46.236534, -0.000021, -0.000029, -89.100097, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2580.259765, -1286.729858, 46.236534, 0.000002, -359.999938, -89.100219, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2580.250732, -1285.196044, 48.067230, -0.000021, 270.000000, -89.100036, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2580.321044, -1283.653198, 43.564697, -0.000021, 179.999984, -89.100036, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2580.370117, -1286.765502, 43.564697, -0.000021, 179.999984, -89.099990, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2582.820312, -1283.614257, 43.564697, -0.000021, 179.999984, -89.100036, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2582.868896, -1286.726196, 43.564697, -0.000021, 179.999984, -89.099990, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2583.572265, -1283.617431, 43.564697, -40.000003, -0.000037, -89.100105, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2583.620361, -1286.668457, 43.564697, -40.000003, -0.000037, -89.100105, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2584.683593, -1285.124755, 44.995983, -40.000003, 270.000000, -89.100074, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 2579.738769, -1285.235473, 47.782455, 0.000029, -0.000021, -179.100219, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "EAST SIDE STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 2577.734375, -1286.236694, 48.192466, 0.000029, -0.000021, -179.100219, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 2653.992675, -1645.698852, 11.024622, 0.000022, -0.000028, 179.599761, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 2652.029052, -1645.684204, 13.062022, -0.000028, -0.000033, -90.000114, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 2652.089111, -1645.723876, 13.062022, 0.000028, 0.000033, 89.999839, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2652.873046, -1645.688842, 12.785304, -0.000028, 270.000000, -90.000007, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2654.083496, -1645.688842, 11.104617, 0.000029, -0.000028, 179.999740, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 2653.747314, -1644.172851, 11.104617, -0.000028, -0.000033, -90.000114, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2653.762207, -1644.152343, 10.954607, -0.000028, -0.000033, -90.000114, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2653.742187, -1647.197387, 11.104617, -0.000004, -359.999938, -90.000221, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2653.762451, -1647.224487, 10.954607, -0.000004, -359.999938, -90.000221, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 2653.999511, -1645.696166, 12.534609, -0.000015, 270.000000, -0.000035, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2654.462890, -1644.157592, 10.954607, -0.000028, -0.000029, -90.000068, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2654.462890, -1647.222534, 10.954607, -0.000004, -359.999938, -90.000190, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2654.477783, -1645.688842, 12.785304, -0.000028, 270.000000, -90.000007, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2654.572509, -1644.147338, 8.282771, -0.000028, 179.999984, -90.000007, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2654.572509, -1647.259887, 8.282771, -0.000028, 179.999984, -89.999961, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2657.072021, -1644.147583, 8.282771, -0.000028, 179.999984, -90.000007, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2657.071777, -1647.259887, 8.282771, -0.000028, 179.999984, -89.999961, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2657.823974, -1644.162597, 8.282771, -40.000007, -0.000037, -90.000076, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2657.824218, -1647.213989, 8.282771, -40.000007, -0.000037, -90.000076, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2658.911376, -1645.687133, 9.714056, -40.000007, 270.000000, -90.000045, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 2653.965576, -1645.720214, 12.500529, 0.000029, -0.000028, 179.999740, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "LOS ANGELES FORUM", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 2651.945556, -1646.689819, 12.910540, 0.000029, -0.000028, 179.999740, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 2305.293701, -1983.383911, 13.733021, 0.000022, -0.000036, 89.599670, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 2305.308349, -1981.420288, 15.770421, -0.000036, -0.000033, 179.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 2305.268554, -1981.480346, 15.770421, 0.000036, 0.000033, -0.000221, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2305.303466, -1982.264282, 15.493702, -0.000036, 270.000000, 179.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2305.303466, -1983.474731, 13.813015, 0.000029, -0.000036, 89.999649, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 2306.819580, -1983.138549, 13.813015, -0.000036, -0.000033, 179.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2306.840087, -1983.153442, 13.663006, -0.000036, -0.000033, 179.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2303.795166, -1983.133422, 13.813015, -0.000012, -359.999938, 179.999664, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2303.767822, -1983.153686, 13.663006, -0.000012, -359.999938, 179.999664, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 2305.296142, -1983.390747, 15.243008, -0.000015, 270.000000, -90.000068, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2306.834716, -1983.854125, 13.663006, -0.000036, -0.000029, 179.999816, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2303.769775, -1983.854125, 13.663006, -0.000012, -359.999938, 179.999694, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2305.303466, -1983.869018, 15.493702, -0.000036, 270.000000, 179.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2306.844970, -1983.963745, 10.991169, -0.000036, 179.999984, 179.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2303.732666, -1983.963745, 10.991169, -0.000036, 179.999984, -179.999893, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2306.844970, -1986.463256, 10.991169, -0.000036, 179.999984, 179.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2303.732666, -1986.463012, 10.991169, -0.000036, 179.999984, -179.999893, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2306.829833, -1987.215209, 10.991169, -40.000003, -0.000037, 179.999816, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2303.778564, -1987.215454, 10.991169, -40.000003, -0.000037, 179.999816, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2305.305419, -1988.302612, 12.422455, -40.000003, 270.000000, 179.999847, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 2305.272216, -1983.356811, 15.208928, 0.000029, -0.000036, 449.999633, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "WILLOWFIELD STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 2304.302490, -1981.336791, 15.618939, 0.000029, -0.000036, 89.999649, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 2236.052734, -1742.272216, 13.736917, 0.000029, -0.000043, 179.599578, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 2234.089111, -1742.257568, 15.774316, -0.000043, -0.000040, -90.000190, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 2234.149169, -1742.297363, 15.774316, 0.000043, 0.000040, 89.999725, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2234.933105, -1742.262451, 15.497598, -0.000043, 270.000000, -90.000083, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2236.143554, -1742.262451, 13.816911, 0.000036, -0.000043, 179.999557, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 2235.807373, -1740.746337, 13.816911, -0.000043, -0.000040, -90.000190, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2235.822265, -1740.725830, 13.666902, -0.000043, -0.000040, -90.000190, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2235.802246, -1743.770751, 13.816911, -0.000019, -359.999938, -90.000297, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 2235.822509, -1743.798095, 13.666902, -0.000019, -359.999938, -90.000297, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 2236.059570, -1742.269775, 15.246904, -0.000022, 270.000000, -0.000076, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 2236.522949, -1740.731201, 13.666902, -0.000043, -0.000036, -90.000144, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2236.522949, -1743.796142, 13.666902, -0.000019, -359.999938, -90.000267, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 2236.537841, -1742.262451, 15.497598, -0.000043, 270.000000, -90.000083, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 2236.632568, -1740.720947, 10.995065, -0.000043, 179.999984, -90.000083, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2236.632568, -1743.833251, 10.995065, -0.000043, 179.999984, -89.999855, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2239.132080, -1740.720947, 10.995065, -0.000043, 179.999984, -90.000083, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 2239.131835, -1743.833251, 10.995065, -0.000043, 179.999984, -89.999855, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2239.884033, -1740.736083, 10.995065, -40.000003, -0.000047, -90.000152, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2239.884277, -1743.787353, 10.995065, -40.000003, -0.000047, -90.000152, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 2240.971435, -1742.260498, 12.426351, -40.000003, 270.000000, -90.000122, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 2236.025634, -1742.293701, 15.212823, 0.000036, -0.000043, 179.999557, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "IDELWOOD STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 2234.005615, -1743.263427, 15.622835, 0.000036, -0.000043, 179.999557, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 1810.023437, -1821.250488, 13.855529, 0.000022, -0.000059, -90.400428, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 1810.008789, -1823.214111, 15.892929, -0.000059, -0.000033, -0.000175, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 1810.048583, -1823.154052, 15.892929, 0.000059, 0.000033, 179.999603, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1810.013671, -1822.370117, 15.616210, -0.000059, 270.000000, -0.000068, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1810.013671, -1821.159667, 13.935523, 0.000029, -0.000059, -90.000450, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 1808.497558, -1821.495849, 13.935523, -0.000059, -0.000033, -0.000175, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1808.477050, -1821.480957, 13.785514, -0.000059, -0.000033, -0.000175, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1811.521972, -1821.500976, 13.935523, -0.000035, -359.999938, -0.000282, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1811.549316, -1821.480712, 13.785514, -0.000035, -359.999938, -0.000282, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 1810.020996, -1821.243652, 15.365516, -0.000015, 270.000000, 89.999870, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1808.482421, -1820.780273, 13.785514, -0.000059, -0.000029, -0.000129, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1811.547363, -1820.780273, 13.785514, -0.000035, -359.999938, -0.000251, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1810.013671, -1820.765380, 15.616210, -0.000059, 270.000000, -0.000068, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1808.472167, -1820.670654, 11.113677, -0.000059, 179.999984, -0.000068, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1811.584472, -1820.670654, 11.113677, -0.000059, 179.999984, 0.000160, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1808.472167, -1818.171142, 11.113677, -0.000059, 179.999984, -0.000068, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1811.584472, -1818.171386, 11.113677, -0.000059, 179.999984, 0.000160, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1808.487304, -1817.419189, 11.113677, -40.000007, -0.000037, -0.000130, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1811.538574, -1817.418945, 11.113677, -40.000007, -0.000037, -0.000130, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1810.011718, -1816.331787, 12.544963, -40.000007, 270.000000, -0.000100, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 1810.044921, -1821.277587, 15.331436, 0.000029, -0.000059, -90.000450, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "UNITY STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 1811.014648, -1823.297607, 15.741447, 0.000029, -0.000059, -90.000450, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 1571.349853, -2238.909423, 13.812948, 0.000014, -0.000051, -0.400436, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 1573.313476, -2238.924072, 15.850347, -0.000051, -0.000025, 89.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 1573.253417, -2238.884277, 15.850347, 0.000051, 0.000025, -90.000358, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1572.469482, -2238.919189, 15.573629, -0.000051, 270.000000, 89.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1571.259033, -2238.919189, 13.892942, 0.000021, -0.000051, -0.000457, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 1571.595214, -2240.435302, 13.892942, -0.000051, -0.000025, 89.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1571.580322, -2240.455810, 13.742933, -0.000051, -0.000025, 89.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1571.600341, -2237.410888, 13.892942, -0.000027, -359.999938, 89.999664, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1571.580078, -2237.383544, 13.742933, -0.000027, -359.999938, 89.999664, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 1571.343017, -2238.911865, 15.322935, -0.000007, 270.000000, 179.999771, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1570.879638, -2240.450439, 13.742933, -0.000051, -0.000021, 89.999816, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1570.879638, -2237.385498, 13.742933, -0.000027, -359.999938, 89.999694, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1570.864746, -2238.919189, 15.573629, -0.000051, 270.000000, 89.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1570.770019, -2240.460693, 11.071096, -0.000051, 179.999984, 89.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1570.770019, -2237.348388, 11.071096, -0.000051, 179.999984, 90.000106, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1568.270507, -2240.460693, 11.071096, -0.000051, 179.999984, 89.999877, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1568.270751, -2237.348388, 11.071096, -0.000051, 179.999984, 90.000106, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1567.518554, -2240.445556, 11.071096, -39.999996, -0.000027, 89.999824, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1567.518310, -2237.394287, 11.071096, -39.999996, -0.000027, 89.999824, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1566.431152, -2238.921142, 12.502382, -39.999996, 270.000000, 89.999855, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 1571.376953, -2238.887939, 15.288854, 0.000021, -0.000051, -0.000457, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "AIRPORT STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 1573.396972, -2237.918212, 15.698865, 0.000021, -0.000051, -0.000457, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);

    tmpobjid = CreateDynamicObject(11714, 934.953491, -1754.479003, 13.756369, 0.000022, -0.000036, 82.599510, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 935.207397, -1752.531738, 15.793768, -0.000036, -0.000033, 172.999649, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 935.160522, -1752.586547, 15.793768, 0.000036, 0.000033, -7.000341, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 935.099609, -1753.368896, 15.517050, -0.000036, 270.000000, 172.999755, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 934.952148, -1754.570312, 13.836363, 0.000029, -0.000036, 82.999496, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 936.497924, -1754.421386, 13.836363, -0.000036, -0.000033, 172.999649, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 936.516479, -1754.438720, 13.686354, -0.000036, -0.000033, 172.999649, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 933.496643, -1754.047729, 13.836363, -0.000012, -359.999938, 172.999542, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 933.467102, -1754.064575, 13.686354, -0.000012, -359.999938, 172.999542, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 934.955078, -1754.485961, 15.266356, -0.000015, 270.000000, -97.000236, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 936.425720, -1755.133422, 13.686354, -0.000036, -0.000029, 172.999694, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 933.383666, -1754.759887, 13.686354, -0.000012, -359.999938, 172.999572, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 934.904052, -1754.961669, 15.517050, -0.000036, 270.000000, 172.999755, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 936.422546, -1755.243530, 11.014517, -0.000036, 179.999984, 172.999755, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 933.333435, -1754.864135, 11.014517, -0.000036, 179.999984, 173.000076, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 936.117919, -1757.724487, 11.014517, -0.000036, 179.999984, 172.999755, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 933.028869, -1757.344848, 11.014517, -0.000036, 179.999984, 173.000076, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 936.011291, -1758.468872, 11.014517, -39.999973, -0.000037, 172.999710, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 932.982666, -1758.097290, 11.014517, -39.999973, -0.000037, 172.999710, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 934.365722, -1759.362426, 12.445803, -39.999973, 270.000000, 172.999740, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 934.935485, -1754.449340, 15.232275, 0.000029, -0.000036, 82.999496, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "VERONA BEACH STATION", 130, "Ariel", 30, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 934.219116, -1752.326293, 15.642287, 0.000029, -0.000036, 82.999496, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 429.466247, -1785.871459, 5.807020, 0.000060, -0.000037, 89.599395, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 429.480957, -1783.907714, 7.844419, -0.000037, -0.000070, 179.999603, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 429.441162, -1783.967773, 7.844419, 0.000037, 0.000070, -0.000346, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 429.476074, -1784.751708, 7.567701, -0.000037, 270.000000, 179.999710, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 429.476104, -1785.962036, 5.887014, 0.000066, -0.000037, 89.999382, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 430.992248, -1785.625854, 5.887014, -0.000037, -0.000070, 179.999603, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 431.012756, -1785.640869, 5.737005, -0.000037, -0.000070, 179.999603, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 427.967742, -1785.620849, 5.887014, -0.000013, -359.999938, 179.999481, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 427.940460, -1785.641113, 5.737005, -0.000013, -359.999938, 179.999481, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 429.468719, -1785.878051, 7.317007, -0.000052, 270.000000, -90.000129, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 431.007324, -1786.341552, 5.737005, -0.000037, -0.000066, 179.999649, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 427.942413, -1786.341430, 5.737005, -0.000013, -359.999938, 179.999511, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 429.476074, -1786.356445, 7.567701, -0.000037, 270.000000, 179.999710, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 431.017547, -1786.451416, 3.065168, -0.000037, 179.999984, 179.999710, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 427.905212, -1786.451171, 3.065168, -0.000037, 179.999984, -179.999694, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 431.017578, -1788.950683, 3.065168, -0.000037, 179.999984, 179.999710, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 427.905242, -1788.950439, 3.065168, -0.000037, 179.999984, -179.999694, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 431.002502, -1789.702514, 3.065168, -39.999973, -0.000086, 179.999633, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 427.951080, -1789.703002, 3.065168, -39.999973, -0.000086, 179.999633, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 429.478088, -1790.790039, 4.496454, -39.999973, 270.000000, 179.999664, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 429.444824, -1785.843994, 7.282927, 0.000066, -0.000037, 89.999382, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "SANTA MARIA BEACH STATION", 130, "Ariel", 30, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 428.475036, -1783.824096, 7.692938, 0.000066, -0.000037, 89.999382, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 520.023986, -1449.154418, 15.416893, 0.000060, -0.000037, -90.400573, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 520.009338, -1451.118164, 17.454292, -0.000037, -0.000070, -0.000457, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 520.049133, -1451.058105, 17.454292, 0.000037, 0.000070, 179.999511, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 520.014221, -1450.274169, 17.177574, -0.000037, 270.000000, -0.000350, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 520.014160, -1449.063842, 15.496888, 0.000066, -0.000037, -90.000587, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 518.497985, -1449.400024, 15.496888, -0.000037, -0.000070, -0.000457, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 518.477478, -1449.385009, 15.346879, -0.000037, -0.000070, -0.000457, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 521.522521, -1449.405029, 15.496888, -0.000013, -359.999938, -0.000579, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 521.549804, -1449.384765, 15.346879, -0.000013, -359.999938, -0.000579, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 520.021545, -1449.147827, 16.926879, -0.000052, 270.000000, 89.999809, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 518.482971, -1448.684326, 15.346879, -0.000037, -0.000066, -0.000411, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 521.547851, -1448.684448, 15.346879, -0.000013, -359.999938, -0.000549, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 520.014221, -1448.669433, 17.177574, -0.000037, 270.000000, -0.000350, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 518.472717, -1448.574462, 12.675042, -0.000037, 179.999984, -0.000350, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 521.585021, -1448.574707, 12.675042, -0.000037, 179.999984, 0.000335, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 518.472717, -1446.075195, 12.675042, -0.000037, 179.999984, -0.000350, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 521.585021, -1446.075439, 12.675042, -0.000037, 179.999984, 0.000335, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 518.487731, -1445.323364, 12.675042, -39.999973, -0.000086, -0.000420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 521.539184, -1445.322875, 12.675042, -39.999973, -0.000086, -0.000420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 520.012145, -1444.235839, 14.106328, -39.999973, 270.000000, -0.000390, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 520.045471, -1449.181884, 16.892799, 0.000066, -0.000037, -90.000587, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "RODEO STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 521.015197, -1451.201782, 17.302810, 0.000066, -0.000037, -90.000587, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 1253.570068, -1417.004028, 13.834183, 0.000060, -0.000037, 89.599365, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 1253.584716, -1415.040283, 15.871582, -0.000037, -0.000070, 179.999435, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 1253.544921, -1415.100341, 15.871582, 0.000037, 0.000070, -0.000503, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1253.579833, -1415.884277, 15.594864, -0.000037, 270.000000, 179.999542, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1253.579956, -1417.094604, 13.914177, 0.000066, -0.000037, 89.999351, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 1255.096069, -1416.758422, 13.914177, -0.000037, -0.000070, 179.999435, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1255.116577, -1416.773437, 13.764168, -0.000037, -0.000070, 179.999435, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1252.071533, -1416.753417, 13.914177, -0.000013, -359.999938, 179.999313, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1252.044311, -1416.773681, 13.764168, -0.000013, -359.999938, 179.999313, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 1253.572509, -1417.010620, 15.344170, -0.000052, 270.000000, -90.000160, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1255.111083, -1417.474121, 13.764168, -0.000037, -0.000066, 179.999481, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1252.046264, -1417.473999, 13.764168, -0.000013, -359.999938, 179.999343, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1253.579833, -1417.489013, 15.594864, -0.000037, 270.000000, 179.999542, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1255.121337, -1417.583984, 11.092332, -0.000037, 179.999984, 179.999542, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1252.009033, -1417.583740, 11.092332, -0.000037, 179.999984, -179.999588, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1255.121337, -1420.083251, 11.092332, -0.000037, 179.999984, 179.999542, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1252.009033, -1420.083007, 11.092332, -0.000037, 179.999984, -179.999588, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1255.106323, -1420.835083, 11.092332, -39.999973, -0.000086, 179.999496, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1252.054809, -1420.835571, 11.092332, -39.999973, -0.000086, 179.999496, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1253.581909, -1421.922607, 12.523618, -39.999973, 270.000000, 179.999526, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 1253.548583, -1416.976562, 15.310090, 0.000066, -0.000037, 89.999351, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "MARKET SQUARE STATION", 130, "Ariel", 30, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 1252.578857, -1414.956665, 15.720101, 0.000066, -0.000037, 89.999351, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 1553.474975, -1150.208618, 24.326925, 0.000060, -0.000037, -90.400604, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 1553.460327, -1152.172363, 26.364324, -0.000037, -0.000070, -0.000579, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 1553.500122, -1152.112304, 26.364324, 0.000037, 0.000070, 179.999389, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1553.465209, -1151.328369, 26.087606, -0.000037, 270.000000, -0.000473, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1553.465087, -1150.118041, 24.406919, 0.000066, -0.000037, -90.000617, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 1551.948974, -1150.454223, 24.406919, -0.000037, -0.000070, -0.000579, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1551.928466, -1150.439208, 24.256910, -0.000037, -0.000070, -0.000579, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1554.973510, -1150.459228, 24.406919, -0.000013, -359.999938, -0.000701, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1555.000732, -1150.438964, 24.256910, -0.000013, -359.999938, -0.000701, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 1553.472534, -1150.202026, 25.836912, -0.000052, 270.000000, 89.999778, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1551.933959, -1149.738525, 24.256910, -0.000037, -0.000066, -0.000534, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1554.998779, -1149.738647, 24.256910, -0.000013, -359.999938, -0.000671, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1553.465209, -1149.723632, 26.087606, -0.000037, 270.000000, -0.000473, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1551.923706, -1149.628662, 21.585073, -0.000037, 179.999984, -0.000473, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1555.036010, -1149.628906, 21.585073, -0.000037, 179.999984, 0.000396, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1551.923706, -1147.129394, 21.585073, -0.000037, 179.999984, -0.000473, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1555.036010, -1147.129638, 21.585073, -0.000037, 179.999984, 0.000396, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1551.938720, -1146.377563, 21.585073, -39.999973, -0.000086, -0.000518, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1554.990234, -1146.377075, 21.585073, -39.999973, -0.000086, -0.000518, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1553.463134, -1145.290039, 23.016359, -39.999973, 270.000000, -0.000488, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 1553.496459, -1150.236083, 25.802831, 0.000066, -0.000037, -90.000617, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "COMMERCIAL STATION", 130, "Ariel", 35, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 1554.466186, -1152.255981, 26.212842, 0.000066, -0.000037, -90.000617, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(11714, 1968.449951, -1271.945922, 24.253925, 0.000060, -0.000037, 89.599334, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 10610, "fedmint_sfs", "ws_security_door", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(2643, 1968.464599, -1269.982177, 26.291324, -0.000037, -0.000070, 179.999313, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(2643, 1968.424804, -1270.042236, 26.291324, 0.000037, 0.000070, -0.000625, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 11631, "mp_ranchcut", "mpcj_speaker_6", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1968.459716, -1270.826171, 26.014606, -0.000037, 270.000000, 179.999420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1968.459838, -1272.036499, 24.333919, 0.000066, -0.000037, 89.999320, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19426, 1969.975952, -1271.700317, 24.333919, -0.000037, -0.000070, 179.999313, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1969.996459, -1271.715332, 24.183910, -0.000037, -0.000070, 179.999313, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1966.951416, -1271.695312, 24.333919, -0.000013, -359.999938, 179.999191, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFCCCCCC);
    tmpobjid = CreateDynamicObject(19426, 1966.924194, -1271.715576, 24.183910, -0.000013, -359.999938, 179.999191, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19940, 1968.452392, -1271.952514, 25.763912, -0.000052, 270.000000, -90.000190, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-90-percent", 0x00000000);
    tmpobjid = CreateDynamicObject(19426, 1969.990966, -1272.416015, 24.183910, -0.000037, -0.000066, 179.999359, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1966.926147, -1272.415893, 24.183910, -0.000013, -359.999938, 179.999221, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19426, 1968.459716, -1272.430908, 26.014606, -0.000037, 270.000000, 179.999420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFFFFFFF);
    tmpobjid = CreateDynamicObject(19353, 1970.001220, -1272.525878, 21.512073, -0.000037, 179.999984, 179.999420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1966.888916, -1272.525634, 21.512073, -0.000037, 179.999984, -179.999526, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1970.001220, -1275.025146, 21.512073, -0.000037, 179.999984, 179.999420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19353, 1966.888916, -1275.024902, 21.512073, -0.000037, 179.999984, -179.999526, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1969.986206, -1275.776977, 21.512073, -39.999973, -0.000086, 179.999389, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1966.934692, -1275.777465, 21.512073, -39.999973, -0.000086, 179.999389, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 17541, "eastbeach2a_lae2", "airportwind02", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19445, 1968.461791, -1276.864501, 22.943359, -39.999973, 270.000000, 179.999420, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterial(tmpobjid, 0, 18646, "matcolours", "grey-70-percent", 0xFFDDDDDD);
    tmpobjid = CreateDynamicObject(19483, 1968.428466, -1271.918457, 25.729831, 0.000066, -0.000037, 89.999320, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "GLEN PARK STATION", 130, "Ariel", 40, 1, 0xFFFFFFFF, 0x00000000, 1);
    tmpobjid = CreateDynamicObject(19483, 1967.458740, -1269.898559, 26.139842, 0.000066, -0.000037, 89.999320, -1, -1, -1, 300.00, 300.00); 
    SetDynamicObjectMaterialText(tmpobjid, 0, "S", 130, "Quartz MS", 199, 1, 0xFFFFFFFF, 0x00000000, 0);
    tmpobjid = CreateDynamicObject(19477, 2236.232910, -1148.244506, 28.113113, 0.000007, -0.000007, 86.599807, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2237.430419, -1148.415283, 27.831031, 0.000014, 0.000014, -3.900093, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2235.095214, -1148.255981, 27.831031, 0.000014, 0.000014, -3.900093, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 2577.719482, -1285.258911, 48.357177, 0.000015, -0.000014, -178.600204, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2577.789550, -1284.051269, 48.075096, 0.000021, 0.000022, 90.899856, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2577.826171, -1286.391601, 48.075096, 0.000021, 0.000022, 90.899856, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 2651.946044, -1645.711914, 13.075251, 0.000014, -0.000021, -179.500152, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2652.035156, -1644.505493, 12.793169, 0.000028, 0.000022, 89.999839, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2652.034912, -1646.846191, 12.793169, 0.000028, 0.000022, 89.999839, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 2305.280517, -1981.337280, 15.783650, 0.000014, -0.000029, 90.499847, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2306.487060, -1981.426391, 15.501568, 0.000036, 0.000022, -0.000221, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2304.146240, -1981.426147, 15.501568, 0.000036, 0.000022, -0.000221, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 2234.006103, -1742.285400, 15.787546, 0.000022, -0.000037, -179.500076, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2234.095214, -1741.078857, 15.505464, 0.000043, 0.000029, 89.999725, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 2234.094970, -1743.419677, 15.505464, 0.000043, 0.000029, 89.999725, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 1810.036621, -1823.297119, 15.906158, 0.000014, -0.000052, -89.499992, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1808.830078, -1823.208007, 15.624076, 0.000059, 0.000022, 179.999603, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1811.170898, -1823.208251, 15.624076, 0.000059, 0.000022, 179.999603, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 1573.396484, -2238.896240, 15.863576, 0.000007, -0.000044, 0.499999, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1573.307373, -2240.102783, 15.581495, 0.000051, 0.000014, -90.000358, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1573.307617, -2237.761962, 15.581495, 0.000051, 0.000014, -90.000358, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 1420.545776, -1718.929321, 15.854024, 0.000007, -0.000036, 0.499999, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1420.456665, -1720.135864, 15.571943, 0.000043, 0.000014, -90.000335, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1420.456909, -1717.795043, 15.571943, 0.000043, 0.000014, -90.000335, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 935.189819, -1752.446044, 15.806998, 0.000014, -0.000029, 83.499946, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 936.376525, -1752.681396, 15.524916, 0.000036, 0.000022, -7.000341, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 934.053222, -1752.395874, 15.524916, 0.000036, 0.000022, -7.000341, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 429.453094, -1783.824829, 7.857649, 0.000052, -0.000030, 90.499832, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 430.659667, -1783.913696, 7.575567, 0.000037, 0.000059, -0.000346, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 428.318878, -1783.913452, 7.575567, 0.000037, 0.000059, -0.000346, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 520.037170, -1451.201049, 17.467521, 0.000052, -0.000030, -89.500137, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 518.830627, -1451.112182, 17.185440, 0.000037, 0.000059, 179.999511, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 521.171386, -1451.112426, 17.185440, 0.000037, 0.000059, 179.999511, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 1253.556884, -1414.957397, 15.884812, 0.000052, -0.000030, 90.499801, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1254.763427, -1415.046264, 15.602730, 0.000037, 0.000059, -0.000503, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1252.422729, -1415.046020, 15.602730, 0.000037, 0.000059, -0.000503, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 1553.488159, -1152.255249, 26.377553, 0.000052, -0.000030, -89.500167, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1552.281616, -1152.166381, 26.095472, 0.000037, 0.000059, 179.999389, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1554.622314, -1152.166625, 26.095472, 0.000037, 0.000059, 179.999389, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19477, 1968.436767, -1269.899291, 26.304553, 0.000052, -0.000030, 90.499771, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1969.643310, -1269.988159, 26.022472, 0.000037, 0.000059, -0.000625, -1, -1, -1, 300.00, 300.00); 
    tmpobjid = CreateDynamicObject(19280, 1967.302612, -1269.987915, 26.022472, 0.000037, 0.000059, -0.000625, -1, -1, -1, 300.00, 300.00); 
}

//=============================================================== [  ]
DialogCreate:d_TRAIN_ARRIVE(playerid)
{
    Dialog_Open(playerid, "d_TRAIN_ARRIVE_BOTH", DIALOG_STYLE_MSGBOX, 
            ""colserver" ",
            "\\c{FFFFFF}   .     .",
            "{FFFFFF}", "");
    return true;
}

DialogCreate:d_BUY_TICKET(playerid)
{
    Dialog_Open(playerid, "d_BUY_TICKET", DIALOG_STYLE_TABLIST_HEADERS,
        ""colserver"     ",
        "{FFFFFF}- \t{FFFFFF}\n\
        {FFFFFF}10 \t{008000}10$\n\
        {FFFFFF}20 \t{008000}20$\n\
        {FFFFFF}30 \t{008000}30$\n\
        {FFFFFF}40 \t{008000}40$\n\
        {FFFFFF}50 \t{008000}50$",
        "{FFFFFF}", "{FFFFFF}");
    return true;
}

DialogResponse:d_BUY_TICKET(playerid, response, listitem, inputtext[])
{
    if(response)
    {
		if(pInfo[playerid][pCash] < 10*listitem) return ErrorMessage(playerid, "   ");
		pInfo[playerid][stickets] += 10*listitem;
		kLibGivePlayerMoney(playerid, -10*listitem, "metro");       		

        if(!Iter_Contains(PlayersInSubway, playerid))
            Iter_Add(PlayersInSubway, playerid);
        new string[90];
        SendClientMessage(playerid, COLOR_SERVER, "[] {FFFFFF}   \
            "colserver"  . {FFFFFF}     .");
        format(string, sizeof(string), "[] {FFFFFF}    "colserver"%d \
            {FFFFFF}.", pInfo[playerid][stickets]);
        SendClientMessage(playerid, COLOR_SERVER, string);
        if(subway_player_train_info[playerid] == false)
        {
            SendClientMessage(playerid, COLOR_SERVER,
                "[] {FFFFFF}     .    \
                "colserver"~5 .");
            SendClientMessage(playerid, COLOR_SERVER,
                "[] {FFFFFF}       ,  \
                  .");
            subway_player_train_info[playerid] = true;
        }
    }
    return true;
}