

#define CAR_ENFORCER 				(427) 
#define CAR_AMBULANCE 				(416)
#define CAR_PONNY 					(413)
#define CAR_BURRITO 				(482)
#define CAR_BERCKLEYS				(459)

#define VEHICLE_ENTER_MSG 			": /v []"
#define VEHICLE_EXIT_DIALOG_CAPTION	" | "colserver""
#define VEHICLE_EXIT_DIALOG_MSG 	"\n{FFFFFF}     ?" 

#define VEHICLE_EXIT_DIALOG_BTN_1	""
#define VEHICLE_EXIT_DIALOG_BTN_2	"x"

#define FRONT_COMPARTMENT_MSG 		" " 
#define REAR_COMPARTMENT_MSG 		" " 
#define VEHICLE_CRASH_MSG			",       ."
#define VEHICLE_EXIT_ERROR_MSG		"   . ,   " 


#define REAR_SEAT_ID 				(2)
#define COMPARTMENT_INT_ID 			(21)
#define VEHICLE_EXIT_DIALOG_ID		(7007) 
#define VEHICLE_EXIT_DIALOG_MSG_LN	(79) 
#define MIN_SPEED_FOR_EXIT_ERROR	(20.00) 
#define COMPARTMENT_MSG_LN 			(14) 


new PlayerVehicleID[MAX_PLAYERS];
new Iterator: TruckPassengers[MAX_VEHICLES]<MAX_PLAYERS>;
new const Float: InteriorPositions[][] =  
{
	{1843.2662, 529.3488, 3052.1602}, // enforcer
	{1829.6780, 919.6672, 3022.8008}, // ambulance
	{2034.2362, 1344.8604, 3010.9063} // burrito, pony, berckleys
};

zsalon_init()
{
	Iter_Init(TruckPassengers);

	foreach(new i : Player)
	{
		PlayerVehicleID[i] = 0;
	}
	
	return 1;
}

zsalon_exit()
{
	for(new v = 0; v < MAX_VEHICLES; v++)
	{
		if(!IsModelTruck(GetVehicleModel(v))) continue;

		Iter_Clear(TruckPassengers[v]);
	}

	foreach(new i : Player)
	{
		PlayerVehicleID[i] = 0;
	}
	return 1;
}


zsalon_statechange(playerid, newstate, oldstate)
{
    switch(newstate)
    {
        case PLAYER_STATE_PASSENGER, PLAYER_STATE_DRIVER:
        {
            new vehicleid = GetPlayerVehicleID(playerid);
            if(vehicleid > 0)
            {
                new model = GetVehicleModel(vehicleid);
                if(IsModelTruck(model))
                {
                    if(GetPlayerVehicleSeat(playerid) >= REAR_SEAT_ID)
                    {
                        switch(model)
                        {
                            case CAR_ENFORCER:
                            {
                                SetPlayerPos(playerid, InteriorPositions[0][0], InteriorPositions[0][1], InteriorPositions[0][2]);
                            }
                            case CAR_AMBULANCE:
                            {
                                SetPlayerPos(playerid, InteriorPositions[1][0], InteriorPositions[1][1], InteriorPositions[1][2]);
                            }
                            case CAR_PONNY, CAR_BURRITO, CAR_BERCKLEYS:
                            {
                                SetPlayerPos(playerid, InteriorPositions[2][0], InteriorPositions[2][1], InteriorPositions[2][2]);
                            }
                        }
                        SetPlayerInterior(playerid, COMPARTMENT_INT_ID);
                        SetPlayerVirtualWorld(playerid, vehicleid);
                        SetPlayerFacingAngle(playerid, 180.00);
                        SetCameraBehindPlayer(playerid);
                    }
                    PlayerVehicleID[playerid] = vehicleid;
                    Iter_Add(TruckPassengers[vehicleid], playerid);
                    SendClientMessage(playerid, COLOR_GREY, VEHICLE_ENTER_MSG);
                    return 1;
                }
            }
        }
        default:
        {
            switch(oldstate)
            {
                case PLAYER_STATE_PASSENGER, PLAYER_STATE_DRIVER:
                {
                    if(PlayerVehicleID[playerid] > 0 && GetPlayerInterior(playerid) != COMPARTMENT_INT_ID)
                    {
                        Iter_Remove(TruckPassengers[PlayerVehicleID[playerid]], playerid);
                        PlayerVehicleID[playerid] = 0;
                    }
                }
            }
        }
    }
    return 1;
}

zsalon_keystate(playerid, oldkeys)
{
	if(oldkeys & KEY_SECONDARY_ATTACK)
	{
		if(PlayerVehicleID[playerid] > 0 && GetPlayerInterior(playerid) == COMPARTMENT_INT_ID)
		{
			new body[VEHICLE_EXIT_DIALOG_MSG_LN + 2];

			format(body, sizeof body, VEHICLE_EXIT_DIALOG_MSG);
			return ShowPlayerDialog(playerid, VEHICLE_EXIT_DIALOG_ID, DIALOG_STYLE_MSGBOX, VEHICLE_EXIT_DIALOG_CAPTION, body, VEHICLE_EXIT_DIALOG_BTN_1, VEHICLE_EXIT_DIALOG_BTN_2);		
		}
	}

	return 1;
}

zsalon_vehdeath(vehicleid)
{
	if(IsModelTruck(GetVehicleModel(vehicleid)))
	{
		foreach(new i : TruckPassengers[vehicleid])
		{
			if(!(0 <= GetPlayerVehicleSeat(i) < REAR_SEAT_ID))
			{
				SendClientMessage(i, COLOR_GREY, VEHICLE_CRASH_MSG);
				SetPlayerHealth(i, 0.00);
			}

			PlayerVehicleID[i] = 0;
		}

		Iter_Clear(TruckPassengers[vehicleid]);
	}

	return 1;
}

zsalon_dialog(playerid, dialogid, response)
{
	if(dialogid == VEHICLE_EXIT_DIALOG_ID)
	{
		if(response)
		{
			if(GetVehicleSpeed(PlayerVehicleID[playerid]) > MIN_SPEED_FOR_EXIT_ERROR)
				return SendClientMessage(playerid, COLOR_GREY, VEHICLE_EXIT_ERROR_MSG);


			new Float: tExPos[3];
			
			GetCoordBootVehicle(PlayerVehicleID[playerid], tExPos[0], tExPos[1], tExPos[2]);

			SetPlayerPos(playerid, tExPos[0], tExPos[1], tExPos[2]);
			SetPlayerFacingAngle(playerid, 180.00);
			SetPlayerVirtualWorld(playerid, GetVehicleVirtualWorld(PlayerVehicleID[playerid]));

			SetPlayerInterior(playerid, 0);
			SetCameraBehindPlayer(playerid);

			Iter_Remove(TruckPassengers[PlayerVehicleID[playerid]], playerid);
			PlayerVehicleID[playerid] = 0;		
		}
	}

	return 1;
}

CMD:v(playerid, params[])
{
	if(PlayerVehicleID[playerid] == 0) return 1;

	extract params -> new string: text[100]; else return SendClientMessage(playerid, COLOR_GREY, VEHICLE_ENTER_MSG);


	new message[sizeof text + MAX_PLAYER_NAME + COMPARTMENT_MSG_LN + 1];
	format(message, sizeof message, "%s %s: %s", (0 <= GetPlayerVehicleSeat(playerid) < REAR_SEAT_ID) ? FRONT_COMPARTMENT_MSG : REAR_COMPARTMENT_MSG, GetName(playerid), text);

	foreach(new i : TruckPassengers[PlayerVehicleID[playerid]])
		SendClientMessage(i, COLOR_BLUE, message);

	return 1;
}

stock IsModelTruck(model)
{
	return model == CAR_ENFORCER || model == CAR_AMBULANCE || model == CAR_PONNY || model == CAR_BURRITO || model == CAR_BERCKLEYS;
}